#ifndef __STC32G_DEF_H__
#define __STC32G_DEF_H__

/////////////////////////////////////////////////

#include "stc32g.h"
#include "def.h"

/////////////////////////////////////////////////

#define PORT_SetQuasiMode(p, b)         CLR_REG_BIT(P##p##M0, (b)); \
                                        CLR_REG_BIT(P##p##M1, (b))

#define PORT_SetPushPullMode(p, b)      SET_REG_BIT(P##p##M0, (b)); \
                                        CLR_REG_BIT(P##p##M1, (b))

#define PORT_SetHighZInputMode(p, b)    CLR_REG_BIT(P##p##M0, (b)); \
                                        SET_REG_BIT(P##p##M1, (b))

#define PORT_SetOpenDrainMode(p, b)     SET_REG_BIT(P##p##M0, (b)); \
                                        SET_REG_BIT(P##p##M1, (b))

#define PORT_EnablePullUp(p, b)         SET_REG_BIT(P##p##PU, (b))
#define PORT_DisablePullUp(p, b)        CLR_REG_BIT(P##p##PU, (b))

#define PORT_EnablePullDown(p, b)       SET_REG_BIT(P##p##PD, (b))
#define PORT_DisablePullDown(p, b)      CLR_REG_BIT(P##p##PD, (b))

#define PORT_EnableSchmitt(p, b)        CLR_REG_BIT(P##p##NCS, (b))
#define PORT_DisableSchmitt(p, b)       SET_REG_BIT(P##p##NCS, (b))

#define PORT_SetSlewRateFast(p, b)      CLR_REG_BIT(P##p##SR, (b))
#define PORT_SetSlewRateNormal(p, b)    SET_REG_BIT(P##p##SR, (b))

#define PORT_SetDrivingStrong(p, b)     CLR_REG_BIT(P##p##DR, (b))
#define PORT_SetDrivingNormal(p, b)     SET_REG_BIT(P##p##DR, (b))

#define PORT_SetAnalogInput(p, b)       CLR_REG_BIT(P##p##IE, (b))
#define PORT_SetDigitalInput(p, b)      SET_REG_BIT(P##p##IE, (b))

#define SetP0nQuasiMode(b)              PORT_SetQuasiMode(0, (b))
#define SetP1nQuasiMode(b)              PORT_SetQuasiMode(1, (b))
#define SetP2nQuasiMode(b)              PORT_SetQuasiMode(2, (b))
#define SetP3nQuasiMode(b)              PORT_SetQuasiMode(3, (b))
#define SetP4nQuasiMode(b)              PORT_SetQuasiMode(4, (b))
#define SetP5nQuasiMode(b)              PORT_SetQuasiMode(5, (b))
#define SetP6nQuasiMode(b)              PORT_SetQuasiMode(6, (b))
#define SetP7nQuasiMode(b)              PORT_SetQuasiMode(7, (b))

#define SetP0nPushPullMode(b)           PORT_SetPushPullMode(0, (b))
#define SetP1nPushPullMode(b)           PORT_SetPushPullMode(1, (b))
#define SetP2nPushPullMode(b)           PORT_SetPushPullMode(2, (b))
#define SetP3nPushPullMode(b)           PORT_SetPushPullMode(3, (b))
#define SetP4nPushPullMode(b)           PORT_SetPushPullMode(4, (b))
#define SetP5nPushPullMode(b)           PORT_SetPushPullMode(5, (b))
#define SetP6nPushPullMode(b)           PORT_SetPushPullMode(6, (b))
#define SetP7nPushPullMode(b)           PORT_SetPushPullMode(7, (b))

#define SetP0nHighZInputMode(b)         PORT_SetHighZInputMode(0, (b))
#define SetP1nHighZInputMode(b)         PORT_SetHighZInputMode(1, (b))
#define SetP2nHighZInputMode(b)         PORT_SetHighZInputMode(2, (b))
#define SetP3nHighZInputMode(b)         PORT_SetHighZInputMode(3, (b))
#define SetP4nHighZInputMode(b)         PORT_SetHighZInputMode(4, (b))
#define SetP5nHighZInputMode(b)         PORT_SetHighZInputMode(5, (b))
#define SetP6nHighZInputMode(b)         PORT_SetHighZInputMode(6, (b))
#define SetP7nHighZInputMode(b)         PORT_SetHighZInputMode(7, (b))

#define SetP0nOpenDrainMode(b)          PORT_SetOpenDrainMode(0, (b))
#define SetP1nOpenDrainMode(b)          PORT_SetOpenDrainMode(1, (b))
#define SetP2nOpenDrainMode(b)          PORT_SetOpenDrainMode(2, (b))
#define SetP3nOpenDrainMode(b)          PORT_SetOpenDrainMode(3, (b))
#define SetP4nOpenDrainMode(b)          PORT_SetOpenDrainMode(4, (b))
#define SetP5nOpenDrainMode(b)          PORT_SetOpenDrainMode(5, (b))
#define SetP6nOpenDrainMode(b)          PORT_SetOpenDrainMode(6, (b))
#define SetP7nOpenDrainMode(b)          PORT_SetOpenDrainMode(7, (b))

#define EnableP0nPullUp(b)              PORT_EnablePullUp(0, (b))
#define EnableP1nPullUp(b)              PORT_EnablePullUp(1, (b))
#define EnableP2nPullUp(b)              PORT_EnablePullUp(2, (b))
#define EnableP3nPullUp(b)              PORT_EnablePullUp(3, (b))
#define EnableP4nPullUp(b)              PORT_EnablePullUp(4, (b))
#define EnableP5nPullUp(b)              PORT_EnablePullUp(5, (b))
#define EnableP6nPullUp(b)              PORT_EnablePullUp(6, (b))
#define EnableP7nPullUp(b)              PORT_EnablePullUp(7, (b))

#define DisableP0nPullUp(b)             PORT_DisablePullUp(0, (b))
#define DisableP1nPullUp(b)             PORT_DisablePullUp(1, (b))
#define DisableP2nPullUp(b)             PORT_DisablePullUp(2, (b))
#define DisableP3nPullUp(b)             PORT_DisablePullUp(3, (b))
#define DisableP4nPullUp(b)             PORT_DisablePullUp(4, (b))
#define DisableP5nPullUp(b)             PORT_DisablePullUp(5, (b))
#define DisableP6nPullUp(b)             PORT_DisablePullUp(6, (b))
#define DisableP7nPullUp(b)             PORT_DisablePullUp(7, (b))

#define EnableP0nPullDown(b)            PORT_EnablePullDown(0, (b))
#define EnableP1nPullDown(b)            PORT_EnablePullDown(1, (b))
#define EnableP2nPullDown(b)            PORT_EnablePullDown(2, (b))
#define EnableP3nPullDown(b)            PORT_EnablePullDown(3, (b))
#define EnableP4nPullDown(b)            PORT_EnablePullDown(4, (b))
#define EnableP5nPullDown(b)            PORT_EnablePullDown(5, (b))
#define EnableP6nPullDown(b)            PORT_EnablePullDown(6, (b))
#define EnableP7nPullDown(b)            PORT_EnablePullDown(7, (b))

#define DisableP0nPullDown(b)           PORT_DisablePullDown(0, (b))
#define DisableP1nPullDown(b)           PORT_DisablePullDown(1, (b))
#define DisableP2nPullDown(b)           PORT_DisablePullDown(2, (b))
#define DisableP3nPullDown(b)           PORT_DisablePullDown(3, (b))
#define DisableP4nPullDown(b)           PORT_DisablePullDown(4, (b))
#define DisableP5nPullDown(b)           PORT_DisablePullDown(5, (b))
#define DisableP6nPullDown(b)           PORT_DisablePullDown(6, (b))
#define DisableP7nPullDown(b)           PORT_DisablePullDown(7, (b))

#define EnableP0nSchmitt(b)             PORT_EnableSchmitt(0, (b))
#define EnableP1nSchmitt(b)             PORT_EnableSchmitt(1, (b))
#define EnableP2nSchmitt(b)             PORT_EnableSchmitt(2, (b))
#define EnableP3nSchmitt(b)             PORT_EnableSchmitt(3, (b))
#define EnableP4nSchmitt(b)             PORT_EnableSchmitt(4, (b))
#define EnableP5nSchmitt(b)             PORT_EnableSchmitt(5, (b))
#define EnableP6nSchmitt(b)             PORT_EnableSchmitt(6, (b))
#define EnableP7nSchmitt(b)             PORT_EnableSchmitt(7, (b))

#define DisableP0nSchmitt(b)            PORT_DisableSchmitt(0, (b))
#define DisableP1nSchmitt(b)            PORT_DisableSchmitt(1, (b))
#define DisableP2nSchmitt(b)            PORT_DisableSchmitt(2, (b))
#define DisableP3nSchmitt(b)            PORT_DisableSchmitt(3, (b))
#define DisableP4nSchmitt(b)            PORT_DisableSchmitt(4, (b))
#define DisableP5nSchmitt(b)            PORT_DisableSchmitt(5, (b))
#define DisableP6nSchmitt(b)            PORT_DisableSchmitt(6, (b))
#define DisableP7nSchmitt(b)            PORT_DisableSchmitt(7, (b))

#define SetP0nSlewRateFast(b)           PORT_SetSlewRateFast(0, (b))
#define SetP1nSlewRateFast(b)           PORT_SetSlewRateFast(1, (b))
#define SetP2nSlewRateFast(b)           PORT_SetSlewRateFast(2, (b))
#define SetP3nSlewRateFast(b)           PORT_SetSlewRateFast(3, (b))
#define SetP4nSlewRateFast(b)           PORT_SetSlewRateFast(4, (b))
#define SetP5nSlewRateFast(b)           PORT_SetSlewRateFast(5, (b))
#define SetP6nSlewRateFast(b)           PORT_SetSlewRateFast(6, (b))
#define SetP7nSlewRateFast(b)           PORT_SetSlewRateFast(7, (b))

#define SetP0nSlewRateNormal(b)         PORT_SetSlewRateNormal(0, (b))
#define SetP1nSlewRateNormal(b)         PORT_SetSlewRateNormal(1, (b))
#define SetP2nSlewRateNormal(b)         PORT_SetSlewRateNormal(2, (b))
#define SetP3nSlewRateNormal(b)         PORT_SetSlewRateNormal(3, (b))
#define SetP4nSlewRateNormal(b)         PORT_SetSlewRateNormal(4, (b))
#define SetP5nSlewRateNormal(b)         PORT_SetSlewRateNormal(5, (b))
#define SetP6nSlewRateNormal(b)         PORT_SetSlewRateNormal(6, (b))
#define SetP7nSlewRateNormal(b)         PORT_SetSlewRateNormal(7, (b))

#define SetP0nDrivingStrong(b)          PORT_SetDrivingStrong(0, (b))
#define SetP1nDrivingStrong(b)          PORT_SetDrivingStrong(1, (b))
#define SetP2nDrivingStrong(b)          PORT_SetDrivingStrong(2, (b))
#define SetP3nDrivingStrong(b)          PORT_SetDrivingStrong(3, (b))
#define SetP4nDrivingStrong(b)          PORT_SetDrivingStrong(4, (b))
#define SetP5nDrivingStrong(b)          PORT_SetDrivingStrong(5, (b))
#define SetP6nDrivingStrong(b)          PORT_SetDrivingStrong(6, (b))
#define SetP7nDrivingStrong(b)          PORT_SetDrivingStrong(7, (b))

#define SetP0nDrivingNormal(b)          PORT_SetDrivingNormal(0, (b))
#define SetP1nDrivingNormal(b)          PORT_SetDrivingNormal(1, (b))
#define SetP2nDrivingNormal(b)          PORT_SetDrivingNormal(2, (b))
#define SetP3nDrivingNormal(b)          PORT_SetDrivingNormal(3, (b))
#define SetP4nDrivingNormal(b)          PORT_SetDrivingNormal(4, (b))
#define SetP5nDrivingNormal(b)          PORT_SetDrivingNormal(5, (b))
#define SetP6nDrivingNormal(b)          PORT_SetDrivingNormal(6, (b))
#define SetP7nDrivingNormal(b)          PORT_SetDrivingNormal(7, (b))

#define SetP0nAnalogInput(b)            PORT_SetAnalogInput(0, (b))
#define SetP1nAnalogInput(b)            PORT_SetAnalogInput(1, (b))
#define SetP2nAnalogInput(b)            PORT_SetAnalogInput(2, (b))
#define SetP3nAnalogInput(b)            PORT_SetAnalogInput(3, (b))
#define SetP4nAnalogInput(b)            PORT_SetAnalogInput(4, (b))
#define SetP5nAnalogInput(b)            PORT_SetAnalogInput(5, (b))
#define SetP6nAnalogInput(b)            PORT_SetAnalogInput(6, (b))
#define SetP7nAnalogInput(b)            PORT_SetAnalogInput(7, (b))

#define SetP0nDigitalInput(b)           PORT_SetDigitalInput(0, (b))
#define SetP1nDigitalInput(b)           PORT_SetDigitalInput(1, (b))
#define SetP2nDigitalInput(b)           PORT_SetDigitalInput(2, (b))
#define SetP3nDigitalInput(b)           PORT_SetDigitalInput(3, (b))
#define SetP4nDigitalInput(b)           PORT_SetDigitalInput(4, (b))
#define SetP5nDigitalInput(b)           PORT_SetDigitalInput(5, (b))
#define SetP6nDigitalInput(b)           PORT_SetDigitalInput(6, (b))
#define SetP7nDigitalInput(b)           PORT_SetDigitalInput(7, (b))

/////////////////////////////////////////////////

#define EnableGlobalInt()               (EA = 1)
#define DisableGlobalInt()              (EA = 0)

#define INT0_EnableInt()                (EX0 = 1)
#define INT0_DisableInt()               (EX0 = 0)

#define INT1_EnableInt()                (EX1 = 1)
#define INT1_DisableInt()               (EX1 = 0)

#define INTCLKO_EX2_MSK                 BIT4
#define INT2_EnableInt()                SET_REG_BIT(INTCLKO, INTCLKO_EX2_MSK)
#define INT2_DisableInt()               CLR_REG_BIT(INTCLKO, INTCLKO_EX2_MSK)

#define INTCLKO_EX3_MSK                 BIT5
#define INT3_EnableInt()                SET_REG_BIT(INTCLKO, INTCLKO_EX3_MSK)
#define INT3_DisableInt()               CLR_REG_BIT(INTCLKO, INTCLKO_EX3_MSK)

#define INTCLKO_EX4_MSK                 BIT6
#define INT4_EnableInt()                SET_REG_BIT(INTCLKO, INTCLKO_EX4_MSK)
#define INT4_DisableInt()               CLR_REG_BIT(INTCLKO, INTCLKO_EX4_MSK)

#define TIMER0_EnableInt()              (ET0 = 1)
#define TIMER0_DisableInt()             (ET0 = 0)

#define TIMER1_EnableInt()              (ET1 = 1)
#define TIMER1_DisableInt()             (ET1 = 0)

#define IE2_ET2_MSK                     BIT2
#define TIMER2_EnableInt()              SET_REG_BIT(IE2, IE2_ET2_MSK)
#define TIMER2_DisableInt()             CLR_REG_BIT(IE2, IE2_ET2_MSK)

#define IE2_ET3_MSK                     BIT5
#define TIMER3_EnableInt()              SET_REG_BIT(IE2, IE2_ET3_MSK)
#define TIMER3_DisableInt()             CLR_REG_BIT(IE2, IE2_ET3_MSK)

#define IE2_ET4_MSK                     BIT6
#define TIMER4_EnableInt()              SET_REG_BIT(IE2, IE2_ET4_MSK)
#define TIMER4_DisableInt()             CLR_REG_BIT(IE2, IE2_ET4_MSK)

#define T11CR_ET11I_MSK                 BIT1
#define TIMER11_EnableInt()             SET_REG_BIT(T11CR, T11CR_ET11I_MSK)
#define TIMER11_DisableInt()            CLR_REG_BIT(T11CR, T11CR_ET11I_MSK)

#define UART1_EnableInt()               (ES = 1)
#define UART1_DisableInt()              (ES = 0)

#define IE2_ES2_MSK                     BIT0
#define UART2_EnableInt()               SET_REG_BIT(IE2, IE2_ES2_MSK)
#define UART2_DisableInt()              CLR_REG_BIT(IE2, IE2_ES2_MSK)

#define IE2_ES3_MSK                     BIT3
#define UART3_EnableInt()               SET_REG_BIT(IE2, IE2_ES3_MSK)
#define UART3_DisableInt()              CLR_REG_BIT(IE2, IE2_ES3_MSK)

#define IE2_ES4_MSK                     BIT4
#define UART4_EnableInt()               SET_REG_BIT(IE2, IE2_ES4_MSK)
#define UART4_DisableInt()              CLR_REG_BIT(IE2, IE2_ES4_MSK)

#define LVD_EnableInt()                 (ELVD = 1)
#define LVD_DisableInt()                (ELVD = 0)

#define ADC_EnableInt()                 (EADC = 1)
#define ADC_DisableInt()                (EADC = 0)

#define IE2_ESPI_MSK                    BIT1
#define SPI_EnableInt()                 SET_REG_BIT(IE2, IE2_ESPI_MSK)
#define SPI_DisableInt()                CLR_REG_BIT(IE2, IE2_ESPI_MSK)

#define IE2_EUSB_MSK                    BIT7
#define USB_EnableInt()                 SET_REG_BIT(IE2, IE2_EUSB_MSK)
#define USB_DisableInt()                CLR_REG_BIT(IE2, IE2_EUSB_MSK)

#define CMPCR1_PIE_MSK                  BIT5
#define CMPCR1_NIE_MSK                  BIT4
#define CMP_EnablePosedgeInt()          SET_REG_BIT(CMPCR1, CMPCR1_PIE_MSK)
#define CMP_EnableNegedgeInt()          SET_REG_BIT(CMPCR1, CMPCR1_NIE_MSK)
#define CMP_EnableEdgeInt()             SET_REG_BIT(CMPCR1, (CMPCR1_PIE_MSK | CMPCR1_NIE_MSK))
#define CMP_DisableInt()                CLR_REG_BIT(CMPCR1, (CMPCR1_PIE_MSK | CMPCR1_NIE_MSK))

#define RTCIEN_ALARM_MSK                BIT7
#define RTCIEN_DAY_MSK                  BIT6
#define RTCIEN_HOUR_MSK                 BIT5
#define RTCIEN_MIN_MSK                  BIT4
#define RTCIEN_SEC_MSK                  BIT3
#define RTCIEN_SEC2_MSK                 BIT2
#define RTCIEN_SEC8_MSK                 BIT1
#define RTCIEN_SEC32_MSK                BIT0
#define RTC_EnableAlarmInt()            SET_REG_BIT(RTCIEN, RTCIEN_ALARM_MSK)
#define RTC_EnableDayInt()              SET_REG_BIT(RTCIEN, RTCIEN_DAY_MSK)
#define RTC_EnableHourInt()             SET_REG_BIT(RTCIEN, RTCIEN_HOUR_MSK)
#define RTC_EnableMinuteInt()           SET_REG_BIT(RTCIEN, RTCIEN_MIN_MSK)
#define RTC_EnableSecondInt()           SET_REG_BIT(RTCIEN, RTCIEN_SEC_MSK)
#define RTC_EnableSecondD2Int()         SET_REG_BIT(RTCIEN, RTCIEN_SEC2_MSK)
#define RTC_EnableSecondD8Int()         SET_REG_BIT(RTCIEN, RTCIEN_SEC8_MSK)
#define RTC_EnableSecondD32Int()        SET_REG_BIT(RTCIEN, RTCIEN_SEC32_MSK)
#define RTC_DisableAlarmInt()           CLR_REG_BIT(RTCIEN, RTCIEN_ALARM_MSK)
#define RTC_DisableDayInt()             CLR_REG_BIT(RTCIEN, RTCIEN_DAY_MSK)
#define RTC_DisableHourInt()            CLR_REG_BIT(RTCIEN, RTCIEN_HOUR_MSK)
#define RTC_DisableMinuteInt()          CLR_REG_BIT(RTCIEN, RTCIEN_MIN_MSK)
#define RTC_DisableSecondInt()          CLR_REG_BIT(RTCIEN, RTCIEN_SEC_MSK)
#define RTC_DisableSecondD2Int()        CLR_REG_BIT(RTCIEN, RTCIEN_SEC2_MSK)
#define RTC_DisableSecondD8Int()        CLR_REG_BIT(RTCIEN, RTCIEN_SEC8_MSK)
#define RTC_DisableSecondD32Int()       CLR_REG_BIT(RTCIEN, RTCIEN_SEC32_MSK)

#define LCMIFIE_MSK                     BIT7
#define LCM_EnableInt()                 SET_REG_BIT(LCMIFCFG, LCMIFIE_MSK)
#define LCM_DisableInt()                CLR_REG_BIT(LCMIFCFG, LCMIFIE_MSK)

#define I2CMSCR_EMSI_MSK                BIT7
#define I2C_EnableMasterInt()           SET_REG_BIT(I2CMSCR, I2CMSCR_EMSI_MSK)
#define I2C_DisableMasterInt()          CLR_REG_BIT(I2CMSCR, I2CMSCR_EMSI_MSK)

#define I2CSLCR_ESTAI_MSK               BIT6
#define I2CSLCR_ERXI_MSK                BIT5
#define I2CSLCR_ETXI_MSK                BIT4
#define I2CSLCR_ESTOI_MSK               BIT3
#define I2C_EnableSlaveSTAInt()         SET_REG_BIT(I2CSLCR, I2CSLCR_ESTAI_MSK)
#define I2C_EnableSlaveSTOInt()         SET_REG_BIT(I2CSLCR, I2CSLCR_ESTOI_MSK)
#define I2C_EnableSlaveRXInt()          SET_REG_BIT(I2CSLCR, I2CSLCR_ERXI_MSK)
#define I2C_EnableSlaveTXInt()          SET_REG_BIT(I2CSLCR, I2CSLCR_ETXI_MSK)
#define I2C_EnableSlaveAllInt()         SET_REG_BIT(I2CSLCR, I2CSLCR_ESTAI_MSK | I2CSLCR_ESTOI_MSK | I2CSLCR_ERXI_MSK | I2CSLCR_ETXI_MSK)
#define I2C_DisableSlaveSTAInt()        CLR_REG_BIT(I2CSLCR, I2CSLCR_ESTAI_MSK)
#define I2C_DisableSlaveSTOInt()        CLR_REG_BIT(I2CSLCR, I2CSLCR_ESTOI_MSK)
#define I2C_DisableSlaveRXInt()         CLR_REG_BIT(I2CSLCR, I2CSLCR_ERXI_MSK)
#define I2C_DisableSlaveTXInt()         CLR_REG_BIT(I2CSLCR, I2CSLCR_ETXI_MSK)
#define I2C_DisableSlaveAllInt()        CLR_REG_BIT(I2CSLCR, I2CSLCR_ESTAI_MSK | I2CSLCR_ESTOI_MSK | I2CSLCR_ERXI_MSK | I2CSLCR_ETXI_MSK)

#define PWMAIER_BIE_MSK                 BIT7
#define PWMAIER_TIE_MSK                 BIT6
#define PWMAIER_COMIE_MSK               BIT5
#define PWMAIER_CC4IE_MSK               BIT4
#define PWMAIER_CC3IE_MSK               BIT3
#define PWMAIER_CC2IE_MSK               BIT2
#define PWMAIER_CC1IE_MSK               BIT1
#define PWMAIER_UIE_MSK                 BIT0
#define PWMA_EnableBreakInt()           SET_REG_BIT(PWMAIER, PWMAIER_BIE_MSK)
#define PWMA_EnableTrigInt()            SET_REG_BIT(PWMAIER, PWMAIER_TIE_MSK)
#define PWMA_EnableCOMInt()             SET_REG_BIT(PWMAIER, PWMAIER_COMIE_MSK)
#define PWMA_EnableCC4Int()             SET_REG_BIT(PWMAIER, PWMAIER_CC4IE_MSK)
#define PWMA_EnableCC3Int()             SET_REG_BIT(PWMAIER, PWMAIER_CC3IE_MSK)
#define PWMA_EnableCC2Int()             SET_REG_BIT(PWMAIER, PWMAIER_CC2IE_MSK)
#define PWMA_EnableCC1Int()             SET_REG_BIT(PWMAIER, PWMAIER_CC1IE_MSK)
#define PWMA_EnableUpdateInt()          SET_REG_BIT(PWMAIER, PWMAIER_UIE_MSK)
#define PWMA_DisableBreakInt()          CLR_REG_BIT(PWMAIER, PWMAIER_BIE_MSK)
#define PWMA_DisableTrigInt()           CLR_REG_BIT(PWMAIER, PWMAIER_TIE_MSK)
#define PWMA_DisableCOMInt()            CLR_REG_BIT(PWMAIER, PWMAIER_COMIE_MSK)
#define PWMA_DisableCC4Int()            CLR_REG_BIT(PWMAIER, PWMAIER_CC4IE_MSK)
#define PWMA_DisableCC3Int()            CLR_REG_BIT(PWMAIER, PWMAIER_CC3IE_MSK)
#define PWMA_DisableCC2Int()            CLR_REG_BIT(PWMAIER, PWMAIER_CC2IE_MSK)
#define PWMA_DisableCC1Int()            CLR_REG_BIT(PWMAIER, PWMAIER_CC1IE_MSK)
#define PWMA_DisableUpdateInt()         CLR_REG_BIT(PWMAIER, PWMAIER_UIE_MSK)

#define PWMBIER_BIE_MSK                 BIT7
#define PWMBIER_TIE_MSK                 BIT6
#define PWMBIER_COMIE_MSK               BIT5
#define PWMBIER_CC4IE_MSK               BIT4
#define PWMBIER_CC3IE_MSK               BIT3
#define PWMBIER_CC2IE_MSK               BIT2
#define PWMBIER_CC1IE_MSK               BIT1
#define PWMBIER_UIE_MSK                 BIT0
#define PWMB_EnableBreakInt()           SET_REG_BIT(PWMBIER, PWMBIER_BIE_MSK)
#define PWMB_EnableTrigInt()            SET_REG_BIT(PWMBIER, PWMBIER_TIE_MSK)
#define PWMB_EnableCOMInt()             SET_REG_BIT(PWMBIER, PWMBIER_COMIE_MSK)
#define PWMB_EnableCC4Int()             SET_REG_BIT(PWMBIER, PWMBIER_CC4IE_MSK)
#define PWMB_EnableCC3Int()             SET_REG_BIT(PWMBIER, PWMBIER_CC3IE_MSK)
#define PWMB_EnableCC2Int()             SET_REG_BIT(PWMBIER, PWMBIER_CC2IE_MSK)
#define PWMB_EnableCC1Int()             SET_REG_BIT(PWMBIER, PWMBIER_CC1IE_MSK)
#define PWMB_EnableUpdateInt()          SET_REG_BIT(PWMBIER, PWMBIER_UIE_MSK)
#define PWMB_DisableBreakInt()          CLR_REG_BIT(PWMBIER, PWMBIER_BIE_MSK)
#define PWMB_DisableTrigInt()           CLR_REG_BIT(PWMBIER, PWMBIER_TIE_MSK)
#define PWMB_DisableCOMInt()            CLR_REG_BIT(PWMBIER, PWMBIER_COMIE_MSK)
#define PWMB_DisableCC4Int()            CLR_REG_BIT(PWMBIER, PWMBIER_CC4IE_MSK)
#define PWMB_DisableCC3Int()            CLR_REG_BIT(PWMBIER, PWMBIER_CC3IE_MSK)
#define PWMB_DisableCC2Int()            CLR_REG_BIT(PWMBIER, PWMBIER_CC2IE_MSK)
#define PWMB_DisableCC1Int()            CLR_REG_BIT(PWMBIER, PWMBIER_CC1IE_MSK)
#define PWMB_DisableUpdateInt()         CLR_REG_BIT(PWMBIER, PWMBIER_UIE_MSK)

#define PORT_EnableInt(p, b)            SET_REG_BIT(P##p##INTE, (b))
#define PORT_DisableInt(p, b)           CLR_REG_BIT(P##p##INTE, (b))

#define EnableP0nInt(b)                 PORT_EnableInt(0, (b))
#define EnableP1nInt(b)                 PORT_EnableInt(1, (b))
#define EnableP2nInt(b)                 PORT_EnableInt(2, (b))
#define EnableP3nInt(b)                 PORT_EnableInt(3, (b))
#define EnableP4nInt(b)                 PORT_EnableInt(4, (b))
#define EnableP5nInt(b)                 PORT_EnableInt(5, (b))
#define EnableP6nInt(b)                 PORT_EnableInt(6, (b))
#define EnableP7nInt(b)                 PORT_EnableInt(7, (b))

#define DisableP0nInt(b)                PORT_DisableInt(0, (b))
#define DisableP1nInt(b)                PORT_DisableInt(1, (b))
#define DisableP2nInt(b)                PORT_DisableInt(2, (b))
#define DisableP3nInt(b)                PORT_DisableInt(3, (b))
#define DisableP4nInt(b)                PORT_DisableInt(4, (b))
#define DisableP5nInt(b)                PORT_DisableInt(5, (b))
#define DisableP6nInt(b)                PORT_DisableInt(6, (b))
#define DisableP7nInt(b)                PORT_DisableInt(7, (b))

#define UR1TOCR_ENTOI_MSK               BIT6
#define UART1_EnableTimeoutInt()        SET_REG_BIT(UR1TOCR, UR1TOCR_ENTOI_MSK)
#define UART1_DisableTimeoutInt()       CLR_REG_BIT(UR1TOCR, UR1TOCR_ENTOI_MSK)

#define UR2TOCR_ENTOI_MSK               BIT6
#define UART2_EnableTimeoutInt()        SET_REG_BIT(UR2TOCR, UR2TOCR_ENTOI_MSK)
#define UART2_DisableTimeoutInt()       CLR_REG_BIT(UR2TOCR, UR2TOCR_ENTOI_MSK)

#define UR3TOCR_ENTOI_MSK               BIT6
#define UART3_EnableTimeoutInt()        SET_REG_BIT(UR3TOCR, UR3TOCR_ENTOI_MSK)
#define UART3_DisableTimeoutInt()       CLR_REG_BIT(UR3TOCR, UR3TOCR_ENTOI_MSK)

#define UR4TOCR_ENTOI_MSK               BIT6
#define UART4_EnableTimeoutInt()        SET_REG_BIT(UR4TOCR, UR4TOCR_ENTOI_MSK)
#define UART4_DisableTimeoutInt()       CLR_REG_BIT(UR4TOCR, UR4TOCR_ENTOI_MSK)

#define SPITOCR_ENTOI_MSK               BIT6
#define SPI_EnableTimeoutInt()          SET_REG_BIT(SPITOCR, SPITOCR_ENTOI_MSK)
#define SPI_DisableTimeoutInt()         CLR_REG_BIT(SPITOCR, SPITOCR_ENTOI_MSK)

#define I2CTOCR_ENTOI_MSK               BIT6
#define I2C_EnableTimeoutInt()          SET_REG_BIT(I2CTOCR, I2CTOCR_ENTOI_MSK)
#define I2C_DisableTimeoutInt()         CLR_REG_BIT(I2CTOCR, I2CTOCR_ENTOI_MSK)

#define DMAM2MCFG_M2MIE_MSK             BIT7
#define DMAADCCFG_ADCIE_MSK             BIT7
#define DMASPICFG_SPIIE_MSK             BIT7
#define DMALCMCFG_LCMIE_MSK             BIT7
#define DMAUR1TCFG_UR1TIE_MSK           BIT7
#define DMAUR1RCFG_UR1RIE_MSK           BIT7
#define DMAUR2TCFG_UR2TIE_MSK           BIT7
#define DMAUR2RCFG_UR2RIE_MSK           BIT7
#define DMAUR3TCFG_UR3TIE_MSK           BIT7
#define DMAUR3RCFG_UR3RIE_MSK           BIT7
#define DMAUR4TCFG_UR4TIE_MSK           BIT7
#define DMAUR4RCFG_UR4RIE_MSK           BIT7
#define DMAI2CTCFG_I2CTIE_MSK           BIT7
#define DMAI2CRCFG_I2CRIE_MSK           BIT7
#define DMA_M2M_EnableInt()             SET_REG_BIT(DMA_M2M_CFG,   DMAM2MCFG_M2MIE_MSK)
#define DMA_ADC_EnableInt()             SET_REG_BIT(DMA_ADC_CFG,   DMAADCCFG_ADCIE_MSK)
#define DMA_SPI_EnableInt()             SET_REG_BIT(DMA_SPI_CFG,   DMASPICFG_SPIIE_MSK)
#define DMA_LCM_EnableInt()             SET_REG_BIT(DMA_LCM_CFG,   DMALCMCFG_LCMIE_MSK)
#define DMA_UART1_EnableTxInt()         SET_REG_BIT(DMA_UR1T_CFG,  DMAUR1TCFG_UR1TIE_MSK)
#define DMA_UART1_EnableRxInt()         SET_REG_BIT(DMA_UR1R_CFG,  DMAUR1RCFG_UR1RIE_MSK)
#define DMA_UART2_EnableTxInt()         SET_REG_BIT(DMA_UR2T_CFG,  DMAUR2TCFG_UR2TIE_MSK)
#define DMA_UART2_EnableRxInt()         SET_REG_BIT(DMA_UR2R_CFG,  DMAUR2RCFG_UR2RIE_MSK)
#define DMA_UART3_EnableTxInt()         SET_REG_BIT(DMA_UR3T_CFG,  DMAUR3TCFG_UR3TIE_MSK)
#define DMA_UART3_EnableRxInt()         SET_REG_BIT(DMA_UR3R_CFG,  DMAUR3RCFG_UR3RIE_MSK)
#define DMA_UART4_EnableTxInt()         SET_REG_BIT(DMA_UR4T_CFG,  DMAUR4TCFG_UR4TIE_MSK)
#define DMA_UART4_EnableRxInt()         SET_REG_BIT(DMA_UR4R_CFG,  DMAUR4RCFG_UR4RIE_MSK)
#define DMA_I2C_EnableTxInt()           SET_REG_BIT(DMA_I2CT_CFG,  DMAI2CTCFG_I2CTIE_MSK)
#define DMA_I2C_EnableRxInt()           SET_REG_BIT(DMA_I2CR_CFG,  DMAI2CRCFG_I2CRIE_MSK)
#define DMA_M2M_DisableInt()            CLR_REG_BIT(DMA_M2M_CFG,   DMAM2MCFG_M2MIE_MSK)
#define DMA_ADC_DisableInt()            CLR_REG_BIT(DMA_ADC_CFG,   DMAADCCFG_ADCIE_MSK)
#define DMA_SPI_DisableInt()            CLR_REG_BIT(DMA_SPI_CFG,   DMASPICFG_SPIIE_MSK)
#define DMA_LCM_DisableInt()            CLR_REG_BIT(DMA_LCM_CFG,   DMALCMCFG_LCMIE_MSK)
#define DMA_UART1_DisableTxInt()        CLR_REG_BIT(DMA_UR1T_CFG,  DMAUR1TCFG_UR1TIE_MSK)
#define DMA_UART1_DisableRxInt()        CLR_REG_BIT(DMA_UR1R_CFG,  DMAUR1RCFG_UR1RIE_MSK)
#define DMA_UART2_DisableTxInt()        CLR_REG_BIT(DMA_UR2T_CFG,  DMAUR2TCFG_UR2TIE_MSK)
#define DMA_UART2_DisableRxInt()        CLR_REG_BIT(DMA_UR2R_CFG,  DMAUR2RCFG_UR2RIE_MSK)
#define DMA_UART3_DisableTxInt()        CLR_REG_BIT(DMA_UR3T_CFG,  DMAUR3TCFG_UR3TIE_MSK)
#define DMA_UART3_DisableRxInt()        CLR_REG_BIT(DMA_UR3R_CFG,  DMAUR3RCFG_UR3RIE_MSK)
#define DMA_UART4_DisableTxInt()        CLR_REG_BIT(DMA_UR4T_CFG,  DMAUR4TCFG_UR4TIE_MSK)
#define DMA_UART4_DisableRxInt()        CLR_REG_BIT(DMA_UR4R_CFG,  DMAUR4RCFG_UR4RIE_MSK)
#define DMA_I2C_DisableTxInt()          CLR_REG_BIT(DMA_I2CT_CFG,  DMAI2CTCFG_I2CTIE_MSK)
#define DMA_I2C_DisableRxInt()          CLR_REG_BIT(DMA_I2CR_CFG,  DMAI2CRCFG_I2CRIE_MSK)

#define INT0_FallingRisingInt()         (IT0 = 0)
#define INT0_FallingInt()               (IT0 = 1)

#define INT0_CheckFlag()                (IE0)
#define INT0_ClearFlag()                (IE0 = 0)

#define INT1_FallingRisingInt()         (IT1 = 0)
#define INT1_FallingInt()               (IT1 = 1)

#define INT1_CheckFlag()                (IE1)
#define INT1_ClearFlag()                (IE1 = 0)

#define AUXINTIF_INT2IF_MSK             BIT4
#define INT2_CheckFlag()                READ_REG_BIT(AUXINTIF, AUXINTIF_INT2IF_MSK)
#define INT2_ClearFlag()                CLR_REG_BIT(AUXINTIF, AUXINTIF_INT2IF_MSK)

#define AUXINTIF_INT3IF_MSK             BIT5
#define INT3_CheckFlag()                READ_REG_BIT(AUXINTIF, AUXINTIF_INT3IF_MSK)
#define INT3_ClearFlag()                CLR_REG_BIT(AUXINTIF, AUXINTIF_INT3IF_MSK)

#define AUXINTIF_INT4IF_MSK             BIT6
#define INT4_CheckFlag()                READ_REG_BIT(AUXINTIF, AUXINTIF_INT4IF_MSK)
#define INT4_ClearFlag()                CLR_REG_BIT(AUXINTIF, AUXINTIF_INT4IF_MSK)

#define TIMER0_CheckFlag()              (TF0)
#define TIMER0_ClearFlag()              (TF0 = 0)

#define TIMER1_CheckFlag()              (TF1)
#define TIMER1_ClearFlag()              (TF1 = 0)

#define AUXINTIF_T2IF_MSK               BIT0
#define TIMER2_CheckFlag()              READ_REG_BIT(AUXINTIF, AUXINTIF_T2IF_MSK)
#define TIMER2_ClearFlag()              CLR_REG_BIT(AUXINTIF, AUXINTIF_T2IF_MSK)

#define AUXINTIF_T3IF_MSK               BIT1
#define TIMER3_CheckFlag()              READ_REG_BIT(AUXINTIF, AUXINTIF_T3IF_MSK)
#define TIMER3_ClearFlag()              CLR_REG_BIT(AUXINTIF, AUXINTIF_T3IF_MSK)

#define AUXINTIF_T4IF_MSK               BIT2
#define TIMER4_CheckFlag()              READ_REG_BIT(AUXINTIF, AUXINTIF_T4IF_MSK)
#define TIMER4_ClearFlag()              CLR_REG_BIT(AUXINTIF, AUXINTIF_T4IF_MSK)

#define T11CR_T11IF_MSK                 BIT0
#define TIMER11_CheckFlag()             READ_REG_BIT(T11CR, T11CR_T11IF_MSK)
#define TIMER11_ClearFlag()             CLR_REG_BIT(T11CR, T11CR_T11IF_MSK)

#define UART1_CheckRxFlag()             (RI)
#define UART1_CheckTxFlag()             (TI)
#define UART1_ClearRxFlag()             (RI = 0)
#define UART1_ClearTxFlag()             (TI = 0)
#define UART1_SetRxFlag()               (RI = 1)
#define UART1_SetTxFlag()               (TI = 1)

#define S2CON_S2TI_MSK                  BIT1
#define S2CON_S2RI_MSK                  BIT0
#define UART2_CheckRxFlag()             READ_REG_BIT(S2CON, S2CON_S2RI_MSK)
#define UART2_CheckTxFlag()             READ_REG_BIT(S2CON, S2CON_S2TI_MSK)
#define UART2_ClearRxFlag()             CLR_REG_BIT(S2CON, S2CON_S2RI_MSK)
#define UART2_ClearTxFlag()             CLR_REG_BIT(S2CON, S2CON_S2TI_MSK)
#define UART2_SetRxFlag()               SET_REG_BIT(S2CON, S2CON_S2RI_MSK)
#define UART2_SetTxFlag()               SET_REG_BIT(S2CON, S2CON_S2TI_MSK)

#define S3CON_S3TI_MSK                  BIT1
#define S3CON_S3RI_MSK                  BIT0
#define UART3_CheckRxFlag()             READ_REG_BIT(S3CON, S3CON_S3RI_MSK)
#define UART3_CheckTxFlag()             READ_REG_BIT(S3CON, S3CON_S3TI_MSK)
#define UART3_ClearRxFlag()             CLR_REG_BIT(S3CON, S3CON_S3RI_MSK)
#define UART3_ClearTxFlag()             CLR_REG_BIT(S3CON, S3CON_S3TI_MSK)
#define UART3_SetRxFlag()               SET_REG_BIT(S3CON, S3CON_S3RI_MSK)
#define UART3_SetTxFlag()               SET_REG_BIT(S3CON, S3CON_S3TI_MSK)

#define S4CON_S4TI_MSK                  BIT1
#define S4CON_S4RI_MSK                  BIT0
#define UART4_CheckRxFlag()             READ_REG_BIT(S4CON, S4CON_S4RI_MSK)
#define UART4_CheckTxFlag()             READ_REG_BIT(S4CON, S4CON_S4TI_MSK)
#define UART4_ClearRxFlag()             CLR_REG_BIT(S4CON, S4CON_S4RI_MSK)
#define UART4_ClearTxFlag()             CLR_REG_BIT(S4CON, S4CON_S4TI_MSK)
#define UART4_SetRxFlag()               SET_REG_BIT(S4CON, S4CON_S4RI_MSK)
#define UART4_SetTxFlag()               SET_REG_BIT(S4CON, S4CON_S4TI_MSK)

#define PCON_LVDF_MSK                   BIT1
#define LVD_CheckFlag()                 READ_REG_BIT(PCON, PCON_LVDF_MSK)
#define LVD_ClearFlag()                 CLR_REG_BIT(PCON, PCON_LVDF_MSK)

#define ADCCONTR_ADCFLAG_MSK            BIT5
#define ADC_CheckFlag()                 READ_REG_BIT(ADC_CONTR, ADCCONTR_ADCFLAG_MSK)
#define ADC_ClearFlag()                 CLR_REG_BIT(ADC_CONTR, ADCCONTR_ADCFLAG_MSK)

#define SPSTAT_SPIF_MSK                 BIT7
#define SPSTAT_WCOL_MSK                 BIT6
#define SPI_CheckFlag()                 READ_REG_BIT(SPSTAT, SPSTAT_SPIF_MSK)
#define SPI_ClearFlag()                 SET_REG_BIT(SPSTAT, SPSTAT_SPIF_MSK | SPSTAT_WCOL_MSK)

#define CMPCR1_CMPIF_MSK                BIT6
#define CMP_CheckFlag()                 READ_REG_BIT(CMPCR1, CMPCR1_CMPIF_MSK)
#define CMP_ClearFlag()                 CLR_REG_BIT(CMPCR1, CMPCR1_CMPIF_MSK)

#define RTCIF_ALARM_MSK                 BIT7
#define RTCIF_DAY_MSK                   BIT6
#define RTCIF_HOUR_MSK                  BIT5
#define RTCIF_MIN_MSK                   BIT4
#define RTCIF_SEC_MSK                   BIT3
#define RTCIF_SEC2_MSK                  BIT2
#define RTCIF_SEC8_MSK                  BIT1
#define RTCIF_SEC32_MSK                 BIT0
#define RTC_CheckAlarmFlag()            READ_REG_BIT(RTCIF, RTCIF_ALARM_MSK)
#define RTC_CheckDayFlag()              READ_REG_BIT(RTCIF, RTCIF_DAY_MSK)
#define RTC_CheckHourFlag()             READ_REG_BIT(RTCIF, RTCIF_HOUR_MSK)
#define RTC_CheckMinuteFlag()           READ_REG_BIT(RTCIF, RTCIF_MIN_MSK)
#define RTC_CheckSecondFlag()           READ_REG_BIT(RTCIF, RTCIF_SEC_MSK)
#define RTC_CheckSecondD2Flag()         READ_REG_BIT(RTCIF, RTCIF_SEC2_MSK)
#define RTC_CheckSecondD8Flag()         READ_REG_BIT(RTCIF, RTCIF_SEC8_MSK)
#define RTC_CheckSecondD32Flag()        READ_REG_BIT(RTCIF, RTCIF_SEC32_MSK)
#define RTC_ClearAlarmFlag()            CLR_REG_BIT(RTCIF, RTCIF_ALARM_MSK)
#define RTC_ClearDayFlag()              CLR_REG_BIT(RTCIF, RTCIF_DAY_MSK)
#define RTC_ClearHourFlag()             CLR_REG_BIT(RTCIF, RTCIF_HOUR_MSK)
#define RTC_ClearMinuteFlag()           CLR_REG_BIT(RTCIF, RTCIF_MIN_MSK)
#define RTC_ClearSecondFlag()           CLR_REG_BIT(RTCIF, RTCIF_SEC_MSK)
#define RTC_ClearSecondD2Flag()         CLR_REG_BIT(RTCIF, RTCIF_SEC2_MSK)
#define RTC_ClearSecondD8Flag()         CLR_REG_BIT(RTCIF, RTCIF_SEC8_MSK)
#define RTC_ClearSecondD32Flag()        CLR_REG_BIT(RTCIF, RTCIF_SEC32_MSK)

#define LCMIFIF_MSK                     BIT0
#define LCM_CheckFlag()                 READ_REG_BIT(LCMIFSTA, LCMIFIF_MSK)
#define LCM_ClearFlag()                 CLR_REG_BIT(LCMIFSTA, LCMIFIF_MSK)

#define I2CMSST_MSIF_MSK                BIT6
#define I2C_CheckMasterFlag()           READ_REG_BIT(I2CMSST, I2CMSST_MSIF_MSK)
#define I2C_ClearMasterFlag()           CLR_REG_BIT(I2CMSST, I2CMSST_MSIF_MSK)

#define I2CSLST_STAIF_MSK               BIT6
#define I2CSLST_RXIF_MSK                BIT5
#define I2CSLST_TXIF_MSK                BIT4
#define I2CSLST_STOIF_MSK               BIT3
#define I2C_CheckSlaveSTAFlag()         READ_REG_BIT(I2CSLST, I2CSLST_STAIF_MSK)
#define I2C_CheckSlaveSTOFlag()         READ_REG_BIT(I2CSLST, I2CSLST_STOIF_MSK)
#define I2C_CheckSlaveRXFlag()          READ_REG_BIT(I2CSLST, I2CSLST_RXIF_MSK)
#define I2C_CheckSlaveTXFlag()          READ_REG_BIT(I2CSLST, I2CSLST_TXIF_MSK)
#define I2C_CheckSlaveAllFlag()         READ_REG_BIT(I2CSLST, I2CSLST_STAIF_MSK | I2CSLST_STOIT_MSK | I2CSLST_RXIT_MSK | I2CSLST_TXIF_MSK)
#define I2C_ClearSlaveSTAFlag()         CLR_REG_BIT(I2CSLST, I2CSLST_STAIF_MSK)
#define I2C_ClearSlaveSTOFlag()         CLR_REG_BIT(I2CSLST, I2CSLST_STOIF_MSK)
#define I2C_ClearSlaveRXFlag()          CLR_REG_BIT(I2CSLST, I2CSLST_RXIF_MSK)
#define I2C_ClearSlaveTXFlag()          CLR_REG_BIT(I2CSLST, I2CSLST_TXIF_MSK)
#define I2C_ClearSlaveAllFlag()         CLR_REG_BIT(I2CSLST, I2CSLST_STAIF_MSK | I2CSLST_STOIT_MSK | I2CSLST_RXIT_MSK | I2CSLST_TXIF_MSK)

#define PWMASR1_BIF_MSK                 BIT7
#define PWMASR1_TIF_MSK                 BIT6
#define PWMASR1_COMIF_MSK               BIT5
#define PWMASR1_CC4IF_MSK               BIT4
#define PWMASR1_CC3IF_MSK               BIT3
#define PWMASR1_CC2IF_MSK               BIT2
#define PWMASR1_CC1IF_MSK               BIT1
#define PWMASR1_UIF_MSK                 BIT0
#define PWMA_CheckBreakFlag()           READ_REG_BIT(PWMASR1, PWMASR1_BIF_MSK)
#define PWMA_CheckTrigFlag()            READ_REG_BIT(PWMASR1, PWMASR1_TIF_MSK)
#define PWMA_CheckCOMFlag()             READ_REG_BIT(PWMASR1, PWMASR1_COMIF_MSK)
#define PWMA_CheckCC4Flag()             READ_REG_BIT(PWMASR1, PWMASR1_CC4IF_MSK)
#define PWMA_CheckCC3Flag()             READ_REG_BIT(PWMASR1, PWMASR1_CC3IF_MSK)
#define PWMA_CheckCC2Flag()             READ_REG_BIT(PWMASR1, PWMASR1_CC2IF_MSK)
#define PWMA_CheckCC1Flag()             READ_REG_BIT(PWMASR1, PWMASR1_CC1IF_MSK)
#define PWMA_CheckUpdateFlag()          READ_REG_BIT(PWMASR1, PWMASR1_UIF_MSK)
#define PWMA_ClearBreakFlag()           CLR_REG_BIT(PWMASR1, PWMASR1_BIF_MSK)
#define PWMA_ClearTrigFlag()            CLR_REG_BIT(PWMASR1, PWMASR1_TIF_MSK)
#define PWMA_ClearCOMFlag()             CLR_REG_BIT(PWMASR1, PWMASR1_COMIF_MSK)
#define PWMA_ClearCC4Flag()             CLR_REG_BIT(PWMASR1, PWMASR1_CC4IF_MSK)
#define PWMA_ClearCC3Flag()             CLR_REG_BIT(PWMASR1, PWMASR1_CC3IF_MSK)
#define PWMA_ClearCC2Flag()             CLR_REG_BIT(PWMASR1, PWMASR1_CC2IF_MSK)
#define PWMA_ClearCC1Flag()             CLR_REG_BIT(PWMASR1, PWMASR1_CC1IF_MSK)
#define PWMA_ClearUpdateFlag()          CLR_REG_BIT(PWMASR1, PWMASR1_UIF_MSK)

#define PWMBSR1_BIF_MSK                 BIT7
#define PWMBSR1_TIF_MSK                 BIT6
#define PWMBSR1_COMIF_MSK               BIT5
#define PWMBSR1_CC4IF_MSK               BIT4
#define PWMBSR1_CC3IF_MSK               BIT3
#define PWMBSR1_CC2IF_MSK               BIT2
#define PWMBSR1_CC1IF_MSK               BIT1
#define PWMBSR1_UIF_MSK                 BIT0
#define PWMB_CheckBreakFlag()           READ_REG_BIT(PWMBSR1, PWMBSR1_BIF_MSK)
#define PWMB_CheckTrigFlag()            READ_REG_BIT(PWMBSR1, PWMBSR1_TIF_MSK)
#define PWMB_CheckCOMFlag()             READ_REG_BIT(PWMBSR1, PWMBSR1_COMIF_MSK)
#define PWMB_CheckCC4Flag()             READ_REG_BIT(PWMBSR1, PWMBSR1_CC4IF_MSK)
#define PWMB_CheckCC3Flag()             READ_REG_BIT(PWMBSR1, PWMBSR1_CC3IF_MSK)
#define PWMB_CheckCC2Flag()             READ_REG_BIT(PWMBSR1, PWMBSR1_CC2IF_MSK)
#define PWMB_CheckCC1Flag()             READ_REG_BIT(PWMBSR1, PWMBSR1_CC1IF_MSK)
#define PWMB_CheckUpdateFlag()          READ_REG_BIT(PWMBSR1, PWMBSR1_UIF_MSK)
#define PWMB_ClearBreakFlag()           CLR_REG_BIT(PWMBSR1, PWMBSR1_BIF_MSK)
#define PWMB_ClearTrigFlag()            CLR_REG_BIT(PWMBSR1, PWMBSR1_TIF_MSK)
#define PWMB_ClearCOMFlag()             CLR_REG_BIT(PWMBSR1, PWMBSR1_COMIF_MSK)
#define PWMB_ClearCC4Flag()             CLR_REG_BIT(PWMBSR1, PWMBSR1_CC4IF_MSK)
#define PWMB_ClearCC3Flag()             CLR_REG_BIT(PWMBSR1, PWMBSR1_CC3IF_MSK)
#define PWMB_ClearCC2Flag()             CLR_REG_BIT(PWMBSR1, PWMBSR1_CC2IF_MSK)
#define PWMB_ClearCC1Flag()             CLR_REG_BIT(PWMBSR1, PWMBSR1_CC1IF_MSK)
#define PWMB_ClearUpdateFlag()          CLR_REG_BIT(PWMBSR1, PWMBSR1_UIF_MSK)

#define PORT_CheckFlag(p, b)            READ_REG_BIT(P##p##INTF, (b))
#define PORT_ClearFlag(p, b)            CLR_REG_BIT(P##p##INTF, (b))

#define CheckP0nFlag(b)                 PORT_CheckFlag(0, (b))
#define CheckP1nFlag(b)                 PORT_CheckFlag(1, (b))
#define CheckP2nFlag(b)                 PORT_CheckFlag(2, (b))
#define CheckP3nFlag(b)                 PORT_CheckFlag(3, (b))
#define CheckP4nFlag(b)                 PORT_CheckFlag(4, (b))
#define CheckP5nFlag(b)                 PORT_CheckFlag(5, (b))
#define CheckP6nFlag(b)                 PORT_CheckFlag(6, (b))
#define CheckP7nFlag(b)                 PORT_CheckFlag(7, (b))
#define ClearP0nFlag(b)                 PORT_ClearFlag(0, (b))
#define ClearP1nFlag(b)                 PORT_ClearFlag(1, (b))
#define ClearP2nFlag(b)                 PORT_ClearFlag(2, (b))
#define ClearP3nFlag(b)                 PORT_ClearFlag(3, (b))
#define ClearP4nFlag(b)                 PORT_ClearFlag(4, (b))
#define ClearP5nFlag(b)                 PORT_ClearFlag(5, (b))
#define ClearP6nFlag(b)                 PORT_ClearFlag(6, (b))
#define ClearP7nFlag(b)                 PORT_ClearFlag(7, (b))

#define UR1TOSR_TOIF_MSK                BIT0
#define UR2TOSR_TOIF_MSK                BIT0
#define UR3TOSR_TOIF_MSK                BIT0
#define UR4TOSR_TOIF_MSK                BIT0
#define SPITOSR_TOIF_MSK                BIT0
#define I2CTOSR_TOIF_MSK                BIT0
#define UART1_CheckTimeoutFlag()        READ_REG_BIT(UR1TOSR, UR1TOSR_TOIF_MSK)
#define UART2_CheckTimeoutFlag()        READ_REG_BIT(UR2TOSR, UR2TOSR_TOIF_MSK)
#define UART3_CheckTimeoutFlag()        READ_REG_BIT(UR3TOSR, UR3TOSR_TOIF_MSK)
#define UART4_CheckTimeoutFlag()        READ_REG_BIT(UR4TOSR, UR4TOSR_TOIF_MSK)
#define SPI_CheckTimeoutFlag()          READ_REG_BIT(SPITOSR, SPITOSR_TOIF_MSK)
#define I2C_CheckTimeoutFlag()          READ_REG_BIT(I2CTOSR, I2CTOSR_TOIF_MSK)

#define UR1TOSR_CTOIF_MSK               BIT7
#define UR2TOSR_CTOIF_MSK               BIT7
#define UR3TOSR_CTOIF_MSK               BIT7
#define UR4TOSR_CTOIF_MSK               BIT7
#define SPITOSR_CTOIF_MSK               BIT7
#define I2CTOSR_CTOIF_MSK               BIT7
#define UART1_ClearTimeoutFlag()        SET_REG_BIT(UR1TOSR, UR1TOSR_CTOIF_MSK)
#define UART2_ClearTimeoutFlag()        SET_REG_BIT(UR2TOSR, UR2TOSR_CTOIF_MSK)
#define UART3_ClearTimeoutFlag()        SET_REG_BIT(UR3TOSR, UR3TOSR_CTOIF_MSK)
#define UART4_ClearTimeoutFlag()        SET_REG_BIT(UR4TOSR, UR4TOSR_CTOIF_MSK)
#define SPI_ClearTimeoutFlag()          SET_REG_BIT(SPITOSR, SPITOSR_CTOIF_MSK)
#define I2C_ClearTimeoutFlag()          SET_REG_BIT(I2CTOSR, I2CTOSR_CTOIF_MSK)

#define DMAM2MSTA_M2MIF_MSK             BIT0
#define DMAADCSTA_ADCIF_MSK             BIT0
#define DMASPISTA_SPIIF_MSK             BIT0
#define DMALCMSTA_LCMIF_MSK             BIT0
#define DMAUR1TSTA_UR1TIF_MSK           BIT0
#define DMAUR1RSTA_UR1RIF_MSK           BIT0
#define DMAUR2TSTA_UR2TIF_MSK           BIT0
#define DMAUR2RSTA_UR2RIF_MSK           BIT0
#define DMAUR3TSTA_UR3TIF_MSK           BIT0
#define DMAUR3RSTA_UR3RIF_MSK           BIT0
#define DMAUR4TSTA_UR4TIF_MSK           BIT0
#define DMAUR4RSTA_UR4RIF_MSK           BIT0
#define DMAI2CTSTA_I2CTIF_MSK           BIT0
#define DMAI2CRSTA_I2CRIF_MSK           BIT0
#define DMA_M2M_CheckFlag()             READ_REG_BIT(DMA_M2M_STA,   DMAM2MSTA_M2MIF_MSK)
#define DMA_ADC_CheckFlag()             READ_REG_BIT(DMA_ADC_STA,   DMAADCSTA_ADCIF_MSK)
#define DMA_SPI_CheckFlag()             READ_REG_BIT(DMA_SPI_STA,   DMASPISTA_SPIIF_MSK)
#define DMA_LCM_CheckFlag()             READ_REG_BIT(DMA_LCM_STA,   DMALCMSTA_LCMIF_MSK)
#define DMA_UART1_CheckTxFlag()         READ_REG_BIT(DMA_UR1T_STA,  DMAUR1TSTA_UR1TIF_MSK)
#define DMA_UART1_CheckRxFlag()         READ_REG_BIT(DMA_UR1R_STA,  DMAUR1RSTA_UR1RIF_MSK)
#define DMA_UART2_CheckTxFlag()         READ_REG_BIT(DMA_UR2T_STA,  DMAUR2TSTA_UR2TIF_MSK)
#define DMA_UART2_CheckRxFlag()         READ_REG_BIT(DMA_UR2R_STA,  DMAUR2RSTA_UR2RIF_MSK)
#define DMA_UART3_CheckTxFlag()         READ_REG_BIT(DMA_UR3T_STA,  DMAUR3TSTA_UR3TIF_MSK)
#define DMA_UART3_CheckRxFlag()         READ_REG_BIT(DMA_UR3R_STA,  DMAUR3RSTA_UR3RIF_MSK)
#define DMA_UART4_CheckTxFlag()         READ_REG_BIT(DMA_UR4T_STA,  DMAUR4TSTA_UR4TIF_MSK)
#define DMA_UART4_CheckRxFlag()         READ_REG_BIT(DMA_UR4R_STA,  DMAUR4RSTA_UR4RIF_MSK)
#define DMA_I2C_CheckTxFlag()           READ_REG_BIT(DMA_I2CT_STA,  DMAI2CTSTA_I2CTIF_MSK)
#define DMA_I2C_CheckRxFlag()           READ_REG_BIT(DMA_I2CR_STA,  DMAI2CRSTA_I2CRIF_MSK)
#define DMA_M2M_ClearFlag()             CLR_REG_BIT(DMA_M2M_STA,    DMAM2MSTA_M2MIF_MSK)
#define DMA_ADC_ClearFlag()             CLR_REG_BIT(DMA_ADC_STA,    DMAADCSTA_ADCIF_MSK)
#define DMA_SPI_ClearFlag()             CLR_REG_BIT(DMA_SPI_STA,    DMASPISTA_SPIIF_MSK)
#define DMA_LCM_ClearFlag()             CLR_REG_BIT(DMA_LCM_STA,    DMALCMSTA_LCMIF_MSK)
#define DMA_UART1_ClearTxFlag()         CLR_REG_BIT(DMA_UR1T_STA,   DMAUR1TSTA_UR1TIF_MSK)
#define DMA_UART1_ClearRxFlag()         CLR_REG_BIT(DMA_UR1R_STA,   DMAUR1RSTA_UR1RIF_MSK)
#define DMA_UART2_ClearTxFlag()         CLR_REG_BIT(DMA_UR2T_STA,   DMAUR2TSTA_UR2TIF_MSK)
#define DMA_UART2_ClearRxFlag()         CLR_REG_BIT(DMA_UR2R_STA,   DMAUR2RSTA_UR2RIF_MSK)
#define DMA_UART3_ClearTxFlag()         CLR_REG_BIT(DMA_UR3T_STA,   DMAUR3TSTA_UR3TIF_MSK)
#define DMA_UART3_ClearRxFlag()         CLR_REG_BIT(DMA_UR3R_STA,   DMAUR3RSTA_UR3RIF_MSK)
#define DMA_UART4_ClearTxFlag()         CLR_REG_BIT(DMA_UR4T_STA,   DMAUR4TSTA_UR4TIF_MSK)
#define DMA_UART4_ClearRxFlag()         CLR_REG_BIT(DMA_UR4R_STA,   DMAUR4RSTA_UR4RIF_MSK)
#define DMA_I2C_ClearTxFlag()           CLR_REG_BIT(DMA_I2CT_STA,   DMAI2CTSTA_I2CTIF_MSK)
#define DMA_I2C_ClearRxFlag()           CLR_REG_BIT(DMA_I2CR_STA,   DMAI2CRSTA_I2CRIF_MSK)

#define IPH_PX0H_MSK                    BIT0
#define INT0_SetIntPriority(n)          PX0 = ((n) & 1); \
                                        MODIFY_REG(IPH, IPH_PX0H_MSK, ((((n) >> 1) & 1) << 0))

#define IPH_PX1H_MSK                    BIT2
#define INT1_SetIntPriority(n)          PX1 = ((n) & 1); \
                                        MODIFY_REG(IPH, IPH_PX1H_MSK, ((((n) >> 1) & 1) << 2))

#define IP2_PX4_MSK                     BIT4
#define IP2H_PX4H_MSK                   BIT4
#define INT4_SetIntPriority(n)          MODIFY_REG(IP2, IP2_PX4_MSK, (((n) & 1) << 4)); \
                                        MODIFY_REG(IP2H, IP2H_PX4H_MSK, ((((n) >> 1) & 1) << 4))

#define IPH_PT0H_MSK                    BIT1
#define TIMER0_SetIntPriority(n)        PT0 = ((n) & 1); \
                                        MODIFY_REG(IPH, IPH_PT0H_MSK, ((((n) >> 1) & 1) << 1))

#define IPH_PT1H_MSK                    BIT3
#define TIMER1_SetIntPriority(n)        PT1 = ((n) & 1); \
                                        MODIFY_REG(IPH, IPH_PT1H_MSK, ((((n) >> 1) & 1) << 3))

#define IPH_PSH_MSK                     BIT4
#define UART1_SetIntPriority(n)         PS = ((n) & 1); \
                                        MODIFY_REG(IPH, IPH_PSH_MSK, ((((n) >> 1) & 1) << 4))

#define IP2_PS2_MSK                     BIT0
#define IP2H_PS2H_MSK                   BIT0
#define UART2_SetIntPriority(n)         MODIFY_REG(IP2, IP2_PS2_MSK, (((n) & 1) << 0)); \
                                        MODIFY_REG(IP2H, IP2H_PS2H_MSK, ((((n) >> 1) & 1) << 0))

#define IP3_PS3_MSK                     BIT0
#define IP3H_PS3H_MSK                   BIT0
#define UART3_SetIntPriority(n)         MODIFY_REG(IP3, IP3_PS3_MSK, (((n) & 1) << 0)); \
                                        MODIFY_REG(IP3H, IP3H_PS3H_MSK, ((((n) >> 1) & 1) << 0))

#define IP3_PS4_MSK                     BIT1
#define IP3H_PS4H_MSK                   BIT1
#define UART4_SetIntPriority(n)         MODIFY_REG(IP3, IP3_PS4_MSK, (((n) & 1) << 1)); \
                                        MODIFY_REG(IP3H, IP3H_PS4H_MSK, ((((n) >> 1) & 1) << 1))

#define IPH_PLVDH_MSK                   BIT6
#define LVD_SetIntPriority(n)           PLVD = ((n) & 1); \
                                        MODIFY_REG(IPH, IPH_PLVDH_MSK, ((((n) >> 1) & 1) << 6))

#define IPH_PADCH_MSK                   BIT5
#define ADC_SetIntPriority(n)           PADC = ((n) & 1); \
                                        MODIFY_REG(IPH, IPH_PADCH_MSK, ((((n) >> 1) & 1) << 5))

#define IP2_PSPI_MSK                    BIT1
#define IP2H_PSPIH_MSK                  BIT1
#define SPI_SetIntPriority(n)           MODIFY_REG(IP2, IP2_PSPI_MSK, (((n) & 1) << 1)); \
                                        MODIFY_REG(IP2H, IP2H_PSPIH_MSK, ((((n) >> 1) & 1) << 1))

#define IP2_PCMP_MSK                    BIT5
#define IP2H_PCMPH_MSK                  BIT5
#define CMP_SetIntPriority(n)           MODIFY_REG(IP2, IP2_PCMP_MSK, (((n) & 1) << 5)); \
                                        MODIFY_REG(IP2H, IP2H_PCMPH_MSK, ((((n) >> 1) & 1) << 5))

#define IP3_PRTC_MSK                    BIT2
#define IP3H_PRTCH_MSK                  BIT2
#define RTC_SetIntPriority(n)           MODIFY_REG(IP3, IP3_PRTC_MSK, (((n) & 1) << 2)); \
                                        MODIFY_REG(IP3H, IP3H_PRTCH_MSK, ((((n) >> 1) & 1) << 2))

#define IP2_PI2C_MSK                    BIT6
#define IP2H_PI2CH_MSK                  BIT6
#define I2C_SetIntPriority(n)           MODIFY_REG(IP2, IP2_PI2C_MSK, (((n) & 1) << 6)); \
                                        MODIFY_REG(IP2H, IP2H_PI2CH_MSK, ((((n) >> 1) & 1) << 6))

#define IP2_PUSB_MSK                    BIT7
#define IP2H_PUSBH_MSK                  BIT7
#define USB_SetIntPriority(n)           MODIFY_REG(IP2, IP2_PUSB_MSK, (((n) & 1) << 7)); \
                                        MODIFY_REG(IP2H, IP2H_PUSBH_MSK, ((((n) >> 1) & 1) << 7))

#define IP2_PPWMA_MSK                   BIT2
#define IP2H_PPWMAH_MSK                 BIT2
#define PWMA_SetIntPriority(n)          MODIFY_REG(IP2, IP2_PPWMA_MSK, (((n) & 1) << 2)); \
                                        MODIFY_REG(IP2H, IP2H_PPWMAH_MSK, ((((n) >> 1) & 1) << 2))

#define IP2_PPWMB_MSK                   BIT3
#define IP2H_PPWMBH_MSK                 BIT3
#define PWMB_SetIntPriority(n)          MODIFY_REG(IP2, IP2_PPWMB_MSK, (((n) & 1) << 3)); \
                                        MODIFY_REG(IP2H, IP2H_PPWMBH_MSK, ((((n) >> 1) & 1) << 3))

#define LCMIFIP_MSK                     (BIT5 | BIT4)
#define LCM_SetIntPriority(n)           MODIFY_REG(LCMIFCFG, LCMIFIP_MSK, ((n) << 4))

#define PORT_SetIntPriority(p, n)       MODIFY_REG(PINIPL, BIT(p), (((n) & 0x01) << (p))); \
                                        MODIFY_REG(PINIPH, BIT(p), ((((n) >> 1) & 0x01) << (p)))

#define SetP0IntPriority(n)             PORT_SetIntPriority(0, (n))
#define SetP1IntPriority(n)             PORT_SetIntPriority(1, (n))
#define SetP2IntPriority(n)             PORT_SetIntPriority(2, (n))
#define SetP3IntPriority(n)             PORT_SetIntPriority(3, (n))
#define SetP4IntPriority(n)             PORT_SetIntPriority(4, (n))
#define SetP5IntPriority(n)             PORT_SetIntPriority(5, (n))
#define SetP6IntPriority(n)             PORT_SetIntPriority(6, (n))
#define SetP7IntPriority(n)             PORT_SetIntPriority(7, (n))

#define DMAM2MCFG_M2MIP_MSK             (BIT3 | BIT2)
#define DMAADCCFG_ADCIP_MSK             (BIT3 | BIT2)
#define DMASPICFG_SPIIP_MSK             (BIT3 | BIT2)
#define DMALCMCFG_LCMIP_MSK             (BIT3 | BIT2)
#define DMAUR1TCFG_UR1TIP_MSK           (BIT3 | BIT2)
#define DMAUR1RCFG_UR1RIP_MSK           (BIT3 | BIT2)
#define DMAUR2TCFG_UR2TIP_MSK           (BIT3 | BIT2)
#define DMAUR2RCFG_UR2RIP_MSK           (BIT3 | BIT2)
#define DMAUR3TCFG_UR3TIP_MSK           (BIT3 | BIT2)
#define DMAUR3RCFG_UR3RIP_MSK           (BIT3 | BIT2)
#define DMAUR4TCFG_UR4TIP_MSK           (BIT3 | BIT2)
#define DMAUR4RCFG_UR4RIP_MSK           (BIT3 | BIT2)
#define DMAI2CTCFG_I2CTIP_MSK           (BIT3 | BIT2)
#define DMAI2CRCFG_I2CRIP_MSK           (BIT3 | BIT2)
#define DMA_M2M_SetIntPriority(n)       MODIFY_REG(DMA_M2M_CFG,   DMAM2MCFG_M2MIP_MSK, ((n) << 2))
#define DMA_ADC_SetIntPriority(n)       MODIFY_REG(DMA_ADC_CFG,   DMAADCCFG_ADCIP_MSK, ((n) << 2))
#define DMA_SPI_SetIntPriority(n)       MODIFY_REG(DMA_SPI_CFG,   DMASPICFG_SPIIP_MSK, ((n) << 2))
#define DMA_LCM_SetIntPriority(n)       MODIFY_REG(DMA_LCM_CFG,   DMALCMCFG_LCMIP_MSK, ((n) << 2))
#define DMA_UART1_SetTxIntPriority(n)   MODIFY_REG(DMA_UR1T_CFG,  DMAUR1TCFG_UR1TIP_MSK, ((n) << 2))
#define DMA_UART1_SetRxIntPriority(n)   MODIFY_REG(DMA_UR1R_CFG,  DMAUR1RCFG_UR1RIP_MSK, ((n) << 2))
#define DMA_UART2_SetTxIntPriority(n)   MODIFY_REG(DMA_UR2T_CFG,  DMAUR2TCFG_UR2TIP_MSK, ((n) << 2))
#define DMA_UART2_SetRxIntPriority(n)   MODIFY_REG(DMA_UR2R_CFG,  DMAUR2RCFG_UR2RIP_MSK, ((n) << 2))
#define DMA_UART3_SetTxIntPriority(n)   MODIFY_REG(DMA_UR3T_CFG,  DMAUR3TCFG_UR3TIP_MSK, ((n) << 2))
#define DMA_UART3_SetRxIntPriority(n)   MODIFY_REG(DMA_UR3R_CFG,  DMAUR3RCFG_UR3RIP_MSK, ((n) << 2))
#define DMA_UART4_SetTxIntPriority(n)   MODIFY_REG(DMA_UR4T_CFG,  DMAUR4TCFG_UR4TIP_MSK, ((n) << 2))
#define DMA_UART4_SetRxIntPriority(n)   MODIFY_REG(DMA_UR4R_CFG,  DMAUR4RCFG_UR4RIP_MSK, ((n) << 2))
#define DMA_I2C_SetTxIntPriority(n)     MODIFY_REG(DMA_I2CT_CFG,  DMAI2CTCFG_I2CTIP_MSK, ((n) << 2))
#define DMA_I2C_SetRxIntPriority(n)     MODIFY_REG(DMA_I2CR_CFG,  DMAI2CRCFG_I2CRIP_MSK, ((n) << 2))

/////////////////////////////////////////////////

#define EAXFR_MSK                       BIT7
#define EnableAccessXFR()               SET_REG_BIT(P_SW2, EAXFR_MSK)

#define AccessCodeSpeed(n)              WRITE_REG(WTST, (n)) 
#define AccessCodeFastest()             AccessCodeSpeed(0)

#define ACCIXRAM_MSK                    (BIT2 | BIT1 | BIT0)
#define AccessIXramSpeed(n)             MODIFY_REG(CKCON, ACCIXRAM_MSK, ((n) << 0))
#define AccessIXramFastest()            AccessIXramSpeed(0)

#define ACCEXRAM_MSK                    (BIT2 | BIT1 | BIT0)
#define AccessEXramSpeed(n)             MODIFY_REG(BUS_SPEED, ACCEXRAM_MSK, ((n) << 0))
#define AccessEXramFastest()            AccessEXramSpeed(0)

#define UART1_PS_MSK                    (BIT7 | BIT6)
#define UART1_SwitchP3031()             MODIFY_REG(P_SW1, UART1_PS_MSK, ((0) << 6))
#define UART1_SwitchP3637()             MODIFY_REG(P_SW1, UART1_PS_MSK, ((1) << 6))
#define UART1_SwitchP1617()             MODIFY_REG(P_SW1, UART1_PS_MSK, ((2) << 6))
#define UART1_SwitchP4344()             MODIFY_REG(P_SW1, UART1_PS_MSK, ((3) << 6))

#define UART2_PS_MSK                    (BIT0)
#define UART2_SwitchP1011()             CLR_REG_BIT(P_SW2, UART2_PS_MSK)
#define UART2_SwitchP4647()             SET_REG_BIT(P_SW2, UART2_PS_MSK)

#define UART3_PS_MSK                    (BIT1)
#define UART3_SwitchP0001()             CLR_REG_BIT(P_SW2, UART3_PS_MSK)
#define UART3_SwitchP5051()             SET_REG_BIT(P_SW2, UART3_PS_MSK)

#define UART4_PS_MSK                    (BIT2)
#define UART4_SwitchP0203()             CLR_REG_BIT(P_SW2, UART4_PS_MSK)
#define UART4_SwitchP5253()             SET_REG_BIT(P_SW2, UART4_PS_MSK)

#define I2C_PS_MSK                      (BIT5 | BIT4)
#define I2C_SwitchP1415()               MODIFY_REG(P_SW2, I2C_PS_MSK, ((0) << 4))
#define I2C_SwitchP2425()               MODIFY_REG(P_SW2, I2C_PS_MSK, ((1) << 4))
#define I2C_SwitchP3332()               MODIFY_REG(P_SW2, I2C_PS_MSK, ((3) << 4))

#define SPI_PS_MSK                      (BIT3 | BIT2)
#define SPI_SwitchP1n()                 MODIFY_REG(P_SW1, SPI_PS_MSK, ((0) << 2))
#define SPI_SwitchP2n()                 MODIFY_REG(P_SW1, SPI_PS_MSK, ((1) << 2))
#define SPI_SwitchP4n()                 MODIFY_REG(P_SW1, SPI_PS_MSK, ((2) << 2))
#define SPI_SwitchP3n()                 MODIFY_REG(P_SW1, SPI_PS_MSK, ((3) << 2))

#define USART1_PS_MSK                   (BIT3 | BIT2)
#define USART1_SwitchP1n()              MODIFY_REG(P_SW3, USART1_PS_MSK, ((0) << 2))
#define USART1_SwitchP2n()              MODIFY_REG(P_SW3, USART1_PS_MSK, ((1) << 2))
#define USART1_SwitchP4n()              MODIFY_REG(P_SW3, USART1_PS_MSK, ((2) << 2))
#define USART1_SwitchP3n()              MODIFY_REG(P_SW3, USART1_PS_MSK, ((3) << 2))

#define USART2_PS_MSK                   (BIT5 | BIT4)
#define USART2_SwitchP1n()              MODIFY_REG(P_SW3, USART2_PS_MSK, ((0) << 4))
#define USART2_SwitchP2n()              MODIFY_REG(P_SW3, USART2_PS_MSK, ((1) << 4))
#define USART2_SwitchP4n()              MODIFY_REG(P_SW3, USART2_PS_MSK, ((2) << 4))
#define USART2_SwitchP3n()              MODIFY_REG(P_SW3, USART2_PS_MSK, ((3) << 4))

#define CMPO_PS_MSK                     (BIT3)
#define CMPO_SwitchP34()                CLR_REG_BIT(P_SW2, CMPO_PS_MSK)
#define CMPO_SwitchP41()                SET_REG_BIT(P_SW2, CMPO_PS_MSK)

#define CMPNS_MSK                       BIT2
#define CMPN_SwitchP36()                CLR_REG_BIT(CMPEXCFG, CMPNS_MSK)
#define CMPN_SwitchREFV()               SET_REG_BIT(CMPEXCFG, CMPNS_MSK)

#define CMPPS_MSK                       (BIT1 | BIT0)
#define CMPP_SwitchP37()                 MODIFY_REG(CMPEXCFG, CMPPS_MSK, ((0) << 0))
#define CMPP_SwitchP50()                 MODIFY_REG(CMPEXCFG, CMPPS_MSK, ((1) << 0))
#define CMPP_SwitchP51()                 MODIFY_REG(CMPEXCFG, CMPPS_MSK, ((2) << 0))
#define CMPP_SwitchADCIN()               MODIFY_REG(CMPEXCFG, CMPPS_MSK, ((3) << 0))

#define MCLKO_PS_MSK                    (BIT7)
#define CLK_SYSCLKO_SwitchP54()         CLR_REG_BIT(MCLKOCR, MCLKO_PS_MSK)
#define CLK_SYSCLKO_SwitchP16()         SET_REG_BIT(MCLKOCR, MCLKO_PS_MSK)

#define PWMA_C1PS_MSK                   (BIT1 | BIT0)
#define PWMA_C1SwitchP1011()            MODIFY_REG(PWMA_PS, PWMA_C1PS_MSK, ((0) << 0))
#define PWMA_C1SwitchP2021()            MODIFY_REG(PWMA_PS, PWMA_C1PS_MSK, ((1) << 0))
#define PWMA_C1SwitchP6061()            MODIFY_REG(PWMA_PS, PWMA_C1PS_MSK, ((2) << 0))
                          
#define PWMA_C2PS_MSK                   (BIT3 | BIT2)
#define PWMA_C2SwitchP5413()            MODIFY_REG(PWMA_PS, PWMA_C2PS_MSK, ((0) << 2))
#define PWMA_C2SwitchP2223()            MODIFY_REG(PWMA_PS, PWMA_C2PS_MSK, ((1) << 2))
#define PWMA_C2SwitchP6263()            MODIFY_REG(PWMA_PS, PWMA_C2PS_MSK, ((2) << 2))
                          
#define PWMA_C3PS_MSK                   (BIT5 | BIT4)
#define PWMA_C3SwitchP1415()            MODIFY_REG(PWMA_PS, PWMA_C3PS_MSK, ((0) << 4))
#define PWMA_C3SwitchP2425()            MODIFY_REG(PWMA_PS, PWMA_C3PS_MSK, ((1) << 4))
#define PWMA_C3SwitchP6465()            MODIFY_REG(PWMA_PS, PWMA_C3PS_MSK, ((2) << 4))
                          
#define PWMA_C4PS_MSK                   (BIT7 | BIT6)
#define PWMA_C4SwitchP1617()            MODIFY_REG(PWMA_PS, PWMA_C4PS_MSK, ((0) << 6))
#define PWMA_C4SwitchP2627()            MODIFY_REG(PWMA_PS, PWMA_C4PS_MSK, ((1) << 6))
#define PWMA_C4SwitchP6667()            MODIFY_REG(PWMA_PS, PWMA_C4PS_MSK, ((2) << 6))

#define PWMB_C5PS_MSK                   (BIT1 | BIT0)
#define PWMB_C5SwitchP20()              MODIFY_REG(PWMB_PS, PWMB_C5PS_MSK, ((0) << 0))
#define PWMB_C5SwitchP17()              MODIFY_REG(PWMB_PS, PWMB_C5PS_MSK, ((1) << 0))
#define PWMB_C5SwitchP00()              MODIFY_REG(PWMB_PS, PWMB_C5PS_MSK, ((2) << 0))
#define PWMB_C5SwitchP74()              MODIFY_REG(PWMB_PS, PWMB_C5PS_MSK, ((3) << 0))
                        
#define PWMB_C6PS_MSK                   (BIT3 | BIT2)
#define PWMB_C6SwitchP21()              MODIFY_REG(PWMB_PS, PWMB_C6PS_MSK, ((0) << 2))
#define PWMB_C6SwitchP54()              MODIFY_REG(PWMB_PS, PWMB_C6PS_MSK, ((1) << 2))
#define PWMB_C6SwitchP01()              MODIFY_REG(PWMB_PS, PWMB_C6PS_MSK, ((2) << 2))
#define PWMB_C6SwitchP75()              MODIFY_REG(PWMB_PS, PWMB_C6PS_MSK, ((3) << 2))
                        
#define PWMB_C7PS_MSK                   (BIT5 | BIT4)
#define PWMB_C7SwitchP22()              MODIFY_REG(PWMB_PS, PWMB_C7PS_MSK, ((0) << 4))
#define PWMB_C7SwitchP33()              MODIFY_REG(PWMB_PS, PWMB_C7PS_MSK, ((1) << 4))
#define PWMB_C7SwitchP02()              MODIFY_REG(PWMB_PS, PWMB_C7PS_MSK, ((2) << 4))
#define PWMB_C7SwitchP76()              MODIFY_REG(PWMB_PS, PWMB_C7PS_MSK, ((3) << 4))
                        
#define PWMB_C8PS_MSK                   (BIT7 | BIT6)
#define PWMB_C8SwitchP23()              MODIFY_REG(PWMB_PS, PWMB_C8PS_MSK, ((0) << 6))
#define PWMB_C8SwitchP34()              MODIFY_REG(PWMB_PS, PWMB_C8PS_MSK, ((1) << 6))
#define PWMB_C8SwitchP03()              MODIFY_REG(PWMB_PS, PWMB_C8PS_MSK, ((2) << 6))
#define PWMB_C8SwitchP77()              MODIFY_REG(PWMB_PS, PWMB_C8PS_MSK, ((3) << 6))

#define PWMA_ETRPS_MSK                  (BIT1 | BIT0)
#define PWMA_ETRSwitchP32()             MODIFY_REG(PWMA_ETRPS, PWMA_ETRPS_MSK, ((0) << 0))
#define PWMA_ETRSwitchP41()             MODIFY_REG(PWMA_ETRPS, PWMA_ETRPS_MSK, ((1) << 0))
#define PWMA_ETRSwitchP73()             MODIFY_REG(PWMA_ETRPS, PWMA_ETRPS_MSK, ((2) << 0))

#define PWMB_ETRPS_MSK                  (BIT1 | BIT0)
#define PWMB_ETRSwitchP32()             MODIFY_REG(PWMB_ETRPS, PWMB_ETRPS_MSK, ((0) << 0))
#define PWMB_ETRSwitchP06()             MODIFY_REG(PWMB_ETRPS, PWMB_ETRPS_MSK, ((1) << 0))

#define PWMA_BRKPS_MSK                  (BIT3 | BIT2)
#define PWMA_BRKSwitchP35()             MODIFY_REG(PWMA_ETRPS, PWMA_BRKPS_MSK, ((0) << 2))
#define PWMA_BRKSwitchCMPO()            MODIFY_REG(PWMA_ETRPS, PWMA_BRKPS_MSK, ((1) << 2))

#define PWMB_BRKPS_MSK                  (BIT3 | BIT2)
#define PWMB_BRKSwitchP35()             MODIFY_REG(PWMB_ETRPS, PWMB_BRKPS_MSK, ((0) << 2))
#define PWMB_BRKSwitchCMPO()            MODIFY_REG(PWMB_ETRPS, PWMB_BRKPS_MSK, ((1) << 2))

#define LCM_DPS_MSK                     (BIT3 | BIT2)
#define LCM_DATA8BSwitchP2()            MODIFY_REG(LCMIFCFG, LCM_DPS_MSK, ((0) << 2))
#define LCM_DATA8BSwitchP6()            MODIFY_REG(LCMIFCFG, LCM_DPS_MSK, ((1) << 2))
#define LCM_DATA16BSwitchP2P0()         MODIFY_REG(LCMIFCFG, LCM_DPS_MSK, ((0) << 2))
#define LCM_DATA16BSwitchP6P2()         MODIFY_REG(LCMIFCFG, LCM_DPS_MSK, ((1) << 2))
#define LCM_DATA16BSwitchP2P4()         MODIFY_REG(LCMIFCFG, LCM_DPS_MSK, ((2) << 2))
#define LCM_DATA16BSwitchP6P7()         MODIFY_REG(LCMIFCFG, LCM_DPS_MSK, ((3) << 2))

#define LCM_RSPS_MSK                    (BIT6)
#define LCM_RSSwitchP45()               CLR_REG_BIT(LCMIFCFG2, LCM_RSPS_MSK)
#define LCM_RSSwitchP40()               SET_REG_BIT(LCMIFCFG2, LCM_RSPS_MSK)

#define LCM_RWPS_MSK                    (BIT5)
#define LCM_CTRLSwitchP4442()           CLR_REG_BIT(LCMIFCFG2, LCM_RWPS_MSK)
#define LCM_CTRLSwitchP3736()           SET_REG_BIT(LCMIFCFG2, LCM_RWPS_MSK)

#define LIN_PS_MSK                      (BIT1 | BIT0)
#define LIN_SwitchP0203()               MODIFY_REG(P_SW1, LIN_PS_MSK, ((0) << 0))
#define LIN_SwitchP5253()               MODIFY_REG(P_SW1, LIN_PS_MSK, ((1) << 0))
#define LIN_SwitchP4647()               MODIFY_REG(P_SW1, LIN_PS_MSK, ((2) << 0))
#define LIN_SwitchP7273()               MODIFY_REG(P_SW1, LIN_PS_MSK, ((3) << 0))

#define CAN1_PS_MSK                     (BIT5 | BIT4)
#define CAN1_SwitchP0001()              MODIFY_REG(P_SW1, CAN1_PS_MSK, ((0) << 4))
#define CAN1_SwitchP5051()              MODIFY_REG(P_SW1, CAN1_PS_MSK, ((1) << 4))
#define CAN1_SwitchP4245()              MODIFY_REG(P_SW1, CAN1_PS_MSK, ((2) << 4))
#define CAN1_SwitchP7071()              MODIFY_REG(P_SW1, CAN1_PS_MSK, ((3) << 4))

#define CAN2_PS_MSK                     (BIT1 | BIT0)
#define CAN2_SwitchP0203()              MODIFY_REG(P_SW3, CAN2_PS_MSK, ((0) << 0))
#define CAN2_SwitchP5253()              MODIFY_REG(P_SW3, CAN2_PS_MSK, ((1) << 0))
#define CAN2_SwitchP4647()              MODIFY_REG(P_SW3, CAN2_PS_MSK, ((2) << 0))
#define CAN2_SwitchP7273()              MODIFY_REG(P_SW3, CAN2_PS_MSK, ((3) << 0))

/////////////////////////////////////////////////

#define CLKSEL_MCKSEL_MSK               (BIT1 | BIT0)
#define CLK_MCLK_HIRC()                 MODIFY_REG(CLKSEL, CLKSEL_MCKSEL_MSK, ((0x00) << 0))
#define CLK_MCLK_XTAL()                 MODIFY_REG(CLKSEL, CLKSEL_MCKSEL_MSK, ((0x01) << 0))
#define CLK_MCLK_X32K()                 MODIFY_REG(CLKSEL, CLKSEL_MCKSEL_MSK, ((0x02) << 0))
#define CLK_MCLK_LIRC()                 MODIFY_REG(CLKSEL, CLKSEL_MCKSEL_MSK, ((0x03) << 0))

#define CLKSEL_MCK2SEL_MSK              (BIT3 | BIT2)
#define CLK_MCLK2_BYPASS()              MODIFY_REG(CLKSEL, CLKSEL_MCK2SEL_MSK, ((0x00) << 2))
#define CLK_MCLK2_PLL()                 MODIFY_REG(CLKSEL, CLKSEL_MCK2SEL_MSK, ((0x01) << 2))
#define CLK_MCLK2_PLLD2()               MODIFY_REG(CLKSEL, CLKSEL_MCK2SEL_MSK, ((0x02) << 2))
#define CLK_MCLK2_IRC48M()              MODIFY_REG(CLKSEL, CLKSEL_MCK2SEL_MSK, ((0x03) << 2))

#define USBCLK_ENCKM_MSK                (BIT7)
#define CLK_PLL_Enable()                SET_REG_BIT(USBCLK, USBCLK_ENCKM_MSK)
#define CLK_PLL_Disable()               CLR_REG_BIT(USBCLK, USBCLK_ENCKM_MSK)

#define USBCLK_PCKI_MSK                 (BIT6 | BIT5)
#define CLK_PLL_PreDivider1()           MODIFY_REG(USBCLK, USBCLK_PCKI_MSK, ((0) << 5))
#define CLK_PLL_PreDivider2()           MODIFY_REG(USBCLK, USBCLK_PCKI_MSK, ((1) << 5))
#define CLK_PLL_PreDivider4()           MODIFY_REG(USBCLK, USBCLK_PCKI_MSK, ((2) << 5))
#define CLK_PLL_PreDivider8()           MODIFY_REG(USBCLK, USBCLK_PCKI_MSK, ((3) << 5))

#define CKSEL_CKMS_MSK                  (BIT7)
#define CLK_PLL_Output96MHz()           CLR_REG_BIT(CLKSEL, CKSEL_CKMS_MSK)
#define CLK_PLL_Output144MHz()          SET_REG_BIT(CLKSEL, CKSEL_CKMS_MSK)

#define CKSEL_HSIOCK_MSK                (BIT6)
#define CLK_HSIOCK_MCLK()               CLR_REG_BIT(CLKSEL, CKSEL_HSIOCK_MSK)
#define CLK_HSIOCK_PLL()                SET_REG_BIT(CLKSEL, CKSEL_HSIOCK_MSK)

#define CLK_HSIOCK_Divider(n)           WRITE_REG(HSCLKDIV, (n))

#define CLK_SYSCLK_Divider(n)           WRITE_REG(CLKDIV, (n))

#define MCLKODIV_MSK                    (~(BIT7))
#define CLK_SYSCLKO_Divider(n)          MODIFY_REG(MCLKOCR, MCLKODIV_MSK, (n))

#define HIRCCR_EN_MSK                   (BIT7)
#define HIRCCR_ST_MSK                   (BIT0)
#define CLK_HIRC_Enable()               SET_REG_BIT(HIRCCR, HIRCCR_EN_MSK)
#define CLK_HIRC_WaitStable()           while (READ_REG_BIT(HIRCCR, HIRCCR_ST_MSK) == 0)

#define IRCBAND_SEL_MSK                 (BIT1 | BIT0)
#define CLK_HIRC_6MHzBand()             MODIFY_REG(IRCBAND, IRCBAND_SEL_MSK, ((0) << 0))
#define CLK_HIRC_10MHzBand()            MODIFY_REG(IRCBAND, IRCBAND_SEL_MSK, ((1) << 0))
#define CLK_HIRC_27MHzBand()            MODIFY_REG(IRCBAND, IRCBAND_SEL_MSK, ((2) << 0))
#define CLK_HIRC_44MHzBand()            MODIFY_REG(IRCBAND, IRCBAND_SEL_MSK, ((3) << 0))

#define IRC48MCR_EN_MSK                 (BIT7)
#define IRC48MCR_ST_MSK                 (BIT0)
#define CLK_IRC48M_Enable()             SET_REG_BIT(IRC48MCR, IRC48MCR_EN_MSK)
#define CLK_IRC48M_WaitStable()         while (READ_REG_BIT(IRC48MCR, IRC48MCR_ST_MSK) == 0)

#define LIRCCR_EN_MSK                   (BIT7)
#define LIRCCR_ST_MSK                   (BIT0)
#define CLK_LIRC_Enable()               SET_REG_BIT(IRC32KCR, LIRCCR_EN_MSK)
#define CLK_LIRC_WaitStable()           while (READ_REG_BIT(IRC32KCR, LIRCCR_ST_MSK) == 0)

#define XOSCCR_EN_MSK                   (BIT7)
#define XOSCCR_XITYPE_MSK               (BIT6)
#define XOSCCR_GAIN_MSK                 (BIT5)
#define XOSCCR_FILTER_MSK               (BIT3 | BIT2)
#define XOSCCR_ST_MSK                   (BIT0)

#define CLK_XTAL_Enable()               SET_REG_BIT(XOSCCR, XOSCCR_EN_MSK | XOSCCR_XITYPE_MSK)
#define CLK_XOSC_Enable()               SET_REG_BIT(XOSCCR, XOSCCR_EN_MSK)
#define CLK_XOSC_WaitStable()           while (READ_REG_BIT(XOSCCR, XOSCCR_ST_MSK) == 0)

#define CLK_XOSC_LowGain()              CLR_REG_BIT(XOSCCR, XOSCCR_GAIN_MSK)
#define CLK_XOSC_FullGain()             SET_REG_BIT(XOSCCR, XOSCCR_GAIN_MSK)

#define CLK_XOSC_HighFilter()           MODIFY_REG(CLKSEL, XOSCCR_FILTER_MSK, ((0) << 2))
#define CLK_XOSC_MiddleFilter()         MODIFY_REG(CLKSEL, XOSCCR_FILTER_MSK, ((1) << 2))
#define CLK_XOSC_LowFilter()            MODIFY_REG(CLKSEL, XOSCCR_FILTER_MSK, ((2) << 2))

#define X32KCR_EN_MSK                   (BIT7)
#define X32KCR_GAIN_MSK                 (BIT6)
#define X32KCR_ST_MSK                   (BIT0)

#define CLK_X32K_Enable()               SET_REG_BIT(X32KCR, X32KCR_EN_MSK)
#define CLK_X32K_WaitStable()           while (READ_REG_BIT(X32KCR, X32KCR_ST_MSK) == 0)

#define CLK_X32K_LowGain()              CLR_REG_BIT(X32KCR, X32KCR_GAIN_MSK)
#define CLK_X32K_FullGain()             SET_REG_BIT(X32KCR, X32KCR_GAIN_MSK)

#define IRCBAND_USBCKS_MSK              (BIT7 | BIT6)
#define USB_CLK_PLLD2()                 MODIFY_REG(IRCBAND, IRCBAND_USBCKS_MSK, ((0) << 6))
#define USB_CLK_IRC48M()                MODIFY_REG(IRCBAND, IRCBAND_USBCKS_MSK, ((2) << 6))
#define USB_CLK_SYSCLK()                MODIFY_REG(IRCBAND, IRCBAND_USBCKS_MSK, ((1) << 6))

/////////////////////////////////////////////////

#define CRECR_ENCRE_MSK                 (BIT7)
#define CRECR_MONO_MSK                  (BIT6)
#define CRECR_UPT_MSK                   (BIT5 | BIT4)
#define CRECR_CREHF_MSK                 (BIT3)
#define CRECR_CREINC_MSK                (BIT2)
#define CRECR_CREDEC_MSK                (BIT1)
#define CRECR_CRERDY_MSK                (BIT0)

#define CRE_Enable()                    SET_REG_BIT(CRECR, CRECR_ENCRE_MSK)
#define CRE_Disable()                   CLR_REG_BIT(CRECR, CRECR_ENCRE_MSK)

#define CRE_OneStepMode()               CLR_REG_BIT(CRECR, CRECR_MONO_MSK)
#define CRE_TwoStepsMode()              SET_REG_BIT(CRECR, CRECR_MONO_MSK)

#define CRE_CalibCycle_1ms()            MODIFY_REG(CRECR, CRECR_UPT_MSK, ((0) << 4))
#define CRE_CalibCycle_4ms()            MODIFY_REG(CRECR, CRECR_UPT_MSK, ((1) << 4))
#define CRE_CalibCycle_32ms()           MODIFY_REG(CRECR, CRECR_UPT_MSK, ((2) << 4))
#define CRE_CalibCycle_64ms()           MODIFY_REG(CRECR, CRECR_UPT_MSK, ((3) << 4))

#define CRE_LowFrequency()              CLR_REG_BIT(CRECR, CRECR_CREHF_MSK)
#define CRE_HighFrequency()             SET_REG_BIT(CRECR, CRECR_CREHF_MSK)

#define CRE_CalibReady()                READ_REG_BIT(CRECR, CRECR_CRERDY_MSK)

#define CRE_LFCNT(freq)                 ((16UL * (freq)) / 32768)
#define CRE_HFCNT(freq)                 ((8UL * (freq)) / 32768)

#define CRE_SetCalibCounter(n)          WRITE_REG(CRECNTH, HIBYTE(n)); \
                                        WRITE_REG(CRECNTL, LOBYTE(n))

#define CRE_LFERROR(freq, err)          ((BYTE)(CRE_LFCNT(freq) * (err) / 1000))
#define CRE_HFERROR(freq, err)          ((BYTE)(CRE_HFCNT(freq) * (err) / 1000))

#define CRE_SetCalibError(n)            WRITE_REG(CRERES, (n))

/////////////////////////////////////////////////

#define WDTCONTR_FLAG_MSK               BIT7
#define WDTCONTR_EN_MSK                 BIT5
#define WDTCONTR_CLR_MSK                BIT4
#define WDTCONTR_IDL_MSK                BIT3
#define WDTCONTR_PS_MSK                 (BIT2 | BIT1 | BIT0)

#define WDT_Enable()                    SET_REG_BIT(WDT_CONTR, WDTCONTR_EN_MSK)
#define WDT_Clear()                     SET_REG_BIT(WDT_CONTR, WDTCONTR_CLR_MSK)
#define WDT_CheckWDTReset()             READ_REG_BIT(WDT_CONTR, WDTCONTR_FLAG_MSK)
#define WDT_IdlePause()                 CLR_REG_BIT(WDT_CONTR, WDTCONTR_IDL_MSK)
#define WDT_IdleContinue()              SET_REG_BIT(WDT_CONTR, WDTCONTR_IDL_MSK)

#define WDT_SetPrescale(n)              MODIFY_REG(WDT_CONTR, WDTCONTR_PS_MSK, ((n) << 0))
#define WDT_SetPrescale2()              WDT_SetPrescale(0)
#define WDT_SetPrescale4()              WDT_SetPrescale(1)
#define WDT_SetPrescale8()              WDT_SetPrescale(2)
#define WDT_SetPrescale16()             WDT_SetPrescale(3)
#define WDT_SetPrescale32()             WDT_SetPrescale(4)
#define WDT_SetPrescale64()             WDT_SetPrescale(5)
#define WDT_SetPrescale128()            WDT_SetPrescale(6)
#define WDT_SetPrescale256()            WDT_SetPrescale(7)

/////////////////////////////////////////////////

#define CHIPID_ReadID0()                CHIPID0
#define CHIPID_ReadID1()                CHIPID1
#define CHIPID_ReadID2()                CHIPID2
#define CHIPID_ReadID3()                CHIPID3
#define CHIPID_ReadID4()                CHIPID4
#define CHIPID_ReadID5()                CHIPID5
#define CHIPID_ReadID6()                CHIPID6
#define CHIPID_ReadREFVoltage()         MAKEWORD(CHIPID8, CHIPID7)
#define CHIPID_ReadLIRCFrequency()      MAKEWORD(CHIPID10, CHIPID9)
#define CHIPID_Read22MIRCTrim()         CHIPID11
#define CHIPID_Read24MIRCTrim()         CHIPID12
#define CHIPID_Read27MIRCTrim()         CHIPID13
#define CHIPID_Read30MIRCTrim()         CHIPID14
#define CHIPID_Read33MIRCTrim()         CHIPID15
#define CHIPID_Read35MIRCTrim()         CHIPID16
#define CHIPID_Read36MIRCTrim()         CHIPID17
#define CHIPID_Read40MIRCTrim()         CHIPID18
#define CHIPID_Read44MIRCTrim()         CHIPID19
#define CHIPID_Read45MIRCTrim()         CHIPID20
#define CHIPID_Read6MVRTrim()           CHIPID21
#define CHIPID_Read10MVRTrim()          CHIPID22
#define CHIPID_Read27MVRTrim()          CHIPID23
#define CHIPID_Read44MVRTrim()          CHIPID24
#define CHIPID_ReadTag()                CHIPID31

#define HIRC_22M1184()                          \
{                                               \
    CLKDIV = 0x04;                              \
    IRTRIM = CHIPID_Read22MIRCTrim();           \
    VRTRIM = CHIPID_Read27MVRTrim();            \
    CLK_HIRC_27MHzBand();                       \
    CLKDIV = 0x00;                              \
}

#define HIRC_24M()                              \
{                                               \
    CLKDIV = 0x04;                              \
    IRTRIM = CHIPID_Read24MIRCTrim();           \
    VRTRIM = CHIPID_Read27MVRTrim();            \
    CLK_HIRC_27MHzBand();                       \
    CLKDIV = 0x00;                              \
}

#define HIRC_27M()                              \
{                                               \
    CLKDIV = 0x04;                              \
    IRTRIM = CHIPID_Read27MIRCTrim();           \
    VRTRIM = CHIPID_Read27MVRTrim();            \
    CLK_HIRC_27MHzBand();                       \
    CLKDIV = 0x00;                              \
}

#define HIRC_30M()                              \
{                                               \
    CLKDIV = 0x04;                              \
    IRTRIM = CHIPID_Read30MIRCTrim();           \
    VRTRIM = CHIPID_Read27MVRTrim();            \
    CLK_HIRC_27MHzBand();                       \
    CLKDIV = 0x00;                              \
}

#define HIRC_33M1776()                          \
{                                               \
    CLKDIV = 0x04;                              \
    IRTRIM = CHIPID_Read33MIRCTrim();           \
    VRTRIM = CHIPID_Read27MVRTrim();            \
    CLK_HIRC_27MHzBand();                       \
    CLKDIV = 0x00;                              \
}

#define HIRC_35M()                              \
{                                               \
    CLKDIV = 0x04;                              \
    IRTRIM = CHIPID_Read35MIRCTrim();           \
    VRTRIM = CHIPID_Read44MVRTrim();            \
    CLK_HIRC_44MHzBand();                       \
    CLKDIV = 0x00;                              \
}

#define HIRC_36M864()                           \
{                                               \
    CLKDIV = 0x04;                              \
    IRTRIM = CHIPID_Read36MIRCTrim();           \
    VRTRIM = CHIPID_Read44MVRTrim();            \
    CLK_HIRC_44MHzBand();                       \
    CLKDIV = 0x00;                              \
}

#define HIRC_40M()                              \
{                                               \
    CLKDIV = 0x04;                              \
    IRTRIM = CHIPID_Read40MIRCTrim();           \
    VRTRIM = CHIPID_Read44MVRTrim();            \
    CLK_HIRC_44MHzBand();                       \
    CLKDIV = 0x00;                              \
}

#define HIRC_44M2368()                          \
{                                               \
    CLKDIV = 0x04;                              \
    IRTRIM = CHIPID_Read44MIRCTrim();           \
    VRTRIM = CHIPID_Read44MVRTrim();            \
    CLK_HIRC_44MHzBand();                       \
    CLKDIV = 0x00;                              \
}

#define HIRC_45M1584()                          \
{                                               \
    CLKDIV = 0x04;                              \
    IRTRIM = CHIPID_Read45MIRCTrim();           \
    VRTRIM = CHIPID_Read44MVRTrim();            \
    CLK_HIRC_44MHzBand();                       \
    CLKDIV = 0x00;                              \
}

/////////////////////////////////////////////////

#define PORT_SetFallingInt(p, b)        CLR_REG_BIT(P##p##IM0, (b)); \
                                        CLR_REG_BIT(P##p##IM1, (b))

#define PORT_SetRisingInt(p, b)         SET_REG_BIT(P##p##IM0, (b)); \
                                        CLR_REG_BIT(P##p##IM1, (b))

#define PORT_SetLowLevelInt(p, b)       CLR_REG_BIT(P##p##IM0, (b)); \
                                        SET_REG_BIT(P##p##IM1, (b))

#define PORT_SetHighLevelInt(p, b)      SET_REG_BIT(P##p##IM0, (b)); \
                                        SET_REG_BIT(P##p##IM1, (b))

#define SetP0nFallingInt(b)             PORT_SetFallingInt(0, (b))
#define SetP1nFallingInt(b)             PORT_SetFallingInt(1, (b))
#define SetP2nFallingInt(b)             PORT_SetFallingInt(2, (b))
#define SetP3nFallingInt(b)             PORT_SetFallingInt(3, (b))
#define SetP4nFallingInt(b)             PORT_SetFallingInt(4, (b))
#define SetP5nFallingInt(b)             PORT_SetFallingInt(5, (b))
#define SetP6nFallingInt(b)             PORT_SetFallingInt(6, (b))
#define SetP7nFallingInt(b)             PORT_SetFallingInt(7, (b))

#define SetP0nRisingInt(b)              PORT_SetRisingInt(0, (b))
#define SetP1nRisingInt(b)              PORT_SetRisingInt(1, (b))
#define SetP2nRisingInt(b)              PORT_SetRisingInt(2, (b))
#define SetP3nRisingInt(b)              PORT_SetRisingInt(3, (b))
#define SetP4nRisingInt(b)              PORT_SetRisingInt(4, (b))
#define SetP5nRisingInt(b)              PORT_SetRisingInt(5, (b))
#define SetP6nRisingInt(b)              PORT_SetRisingInt(6, (b))
#define SetP7nRisingInt(b)              PORT_SetRisingInt(7, (b))

#define SetP0nLowLevelInt(b)            PORT_SetLowLevelInt(0, (b))
#define SetP1nLowLevelInt(b)            PORT_SetLowLevelInt(1, (b))
#define SetP2nLowLevelInt(b)            PORT_SetLowLevelInt(2, (b))
#define SetP3nLowLevelInt(b)            PORT_SetLowLevelInt(3, (b))
#define SetP4nLowLevelInt(b)            PORT_SetLowLevelInt(4, (b))
#define SetP5nLowLevelInt(b)            PORT_SetLowLevelInt(5, (b))
#define SetP6nLowLevelInt(b)            PORT_SetLowLevelInt(6, (b))
#define SetP7nLowLevelInt(b)            PORT_SetLowLevelInt(7, (b))

#define SetP0nHighLevelInt(b)           PORT_SetHighLevelInt(0, (b))
#define SetP1nHighLevelInt(b)           PORT_SetHighLevelInt(1, (b))
#define SetP2nHighLevelInt(b)           PORT_SetHighLevelInt(2, (b))
#define SetP3nHighLevelInt(b)           PORT_SetHighLevelInt(3, (b))
#define SetP4nHighLevelInt(b)           PORT_SetHighLevelInt(4, (b))
#define SetP5nHighLevelInt(b)           PORT_SetHighLevelInt(5, (b))
#define SetP6nHighLevelInt(b)           PORT_SetHighLevelInt(6, (b))
#define SetP7nHighLevelInt(b)           PORT_SetHighLevelInt(7, (b))

#define PORT_EnableIntWaieup(p, b)      SET_REG_BIT(P##p##WKUE, (b))

#define SetP0nIntWaieup(b)              PORT_EnableIntWaieup(0, (b))
#define SetP1nIntWaieup(b)              PORT_EnableIntWaieup(1, (b))
#define SetP2nIntWaieup(b)              PORT_EnableIntWaieup(2, (b))
#define SetP3nIntWaieup(b)              PORT_EnableIntWaieup(3, (b))
#define SetP4nIntWaieup(b)              PORT_EnableIntWaieup(4, (b))
#define SetP5nIntWaieup(b)              PORT_EnableIntWaieup(5, (b))
#define SetP6nIntWaieup(b)              PORT_EnableIntWaieup(6, (b))
#define SetP7nIntWaieup(b)              PORT_EnableIntWaieup(7, (b))

/////////////////////////////////////////////////

#define TIMER0_Run()                    (TR0 = 1)
#define TIMER0_Stop()                   (TR0 = 0)

#define TIMER0_SetReload8(n)            (TH0 = LOBYTE(n), TL0 = LOBYTE(n))
#define TIMER0_SetReload16(n)           (TH0 = HIBYTE(n), TL0 = LOBYTE(n))
#define TIMER0_SetPrescale(n)           (TM0PS = (n))

#define TMOD_T0M_MSK                    (BIT1 | BIT0)
#define TIMER0_Mode0()                  MODIFY_REG(TMOD, TMOD_T0M_MSK, ((0) << 0))
#define TIMER0_Mode1()                  MODIFY_REG(TMOD, TMOD_T0M_MSK, ((1) << 0))
#define TIMER0_Mode2()                  MODIFY_REG(TMOD, TMOD_T0M_MSK, ((2) << 0))
#define TIMER0_Mode3()                  MODIFY_REG(TMOD, TMOD_T0M_MSK, ((3) << 0))

#define AUXR_T0X12_MSK                  BIT7
#define TIMER0_1TMode()                 SET_REG_BIT(AUXR, AUXR_T0X12_MSK)
#define TIMER0_12TMode()                CLR_REG_BIT(AUXR, AUXR_T0X12_MSK)

#define TMOD_T0CT_MSK                   BIT2
#define TIMER0_TimerMode()              CLR_REG_BIT(TMOD, TMOD_T0CT_MSK)
#define TIMER0_CounterMode()            SET_REG_BIT(TMOD, TMOD_T0CT_MSK)

#define TMOD_T0GATE_MSK                 BIT3
#define TIMER0_EnableGateINT0()         SET_REG_BIT(TMOD, TMOD_T0GATE_MSK)
#define TIMER0_DisableGateINT0()        CLR_REG_BIT(TMOD, TMOD_T0GATE_MSK)

#define INTCLKO_T0CLKO_MSK              BIT0
#define TIMER0_EnableCLKO()             SET_REG_BIT(INTCLKO, INTCLKO_T0CLKO_MSK)
#define TIMER0_DisableCLKO()            CLR_REG_BIT(INTCLKO, INTCLKO_T0CLKO_MSK)

////////////////////////

#define TIMER1_Run()                    (TR1 = 1)
#define TIMER1_Stop()                   (TR1 = 0)
#define TIMER1_CheckFlag()              (TF1)
#define TIMER1_ClearFlag()              (TF1 = 0)

#define TIMER1_SetReload8(n)            (TH1 = LOBYTE(n), TL1 = LOBYTE(n))
#define TIMER1_SetReload16(n)           (TH1 = HIBYTE(n), TL1 = LOBYTE(n))
#define TIMER1_SetPrescale(n)           (TM1PS = (n))

#define TMOD_T1M_MSK                    (BIT5 | BIT4)
#define TIMER1_Mode0()                  MODIFY_REG(TMOD, TMOD_T1M_MSK, ((0) << 0))
#define TIMER1_Mode1()                  MODIFY_REG(TMOD, TMOD_T1M_MSK, ((1) << 0))
#define TIMER1_Mode2()                  MODIFY_REG(TMOD, TMOD_T1M_MSK, ((2) << 0))

#define AUXR_T1X12_MSK                  BIT6
#define TIMER1_1TMode()                 SET_REG_BIT(AUXR, AUXR_T1X12_MSK)
#define TIMER1_12TMode()                CLR_REG_BIT(AUXR, AUXR_T1X12_MSK)

#define TMOD_T1CT_MSK                   BIT6
#define TIMER1_TimerMode()              CLR_REG_BIT(TMOD, TMOD_T1CT_MSK)
#define TIMER1_CounterMode()            SET_REG_BIT(TMOD, TMOD_T1CT_MSK)

#define TMOD_T1GATE_MSK                 BIT7
#define TIMER1_EnableGateINT1()         SET_REG_BIT(TMOD, TMOD_T1GATE_MSK)
#define TIMER1_DisableGateINT1()        CLR_REG_BIT(TMOD, TMOD_T1GATE_MSK)

#define INTCLKO_T1CLKO_MSK              BIT1
#define TIMER1_EnableCLKO()             SET_REG_BIT(INTCLKO, INTCLKO_T1CLKO_MSK)
#define TIMER1_DisableCLKO()            CLR_REG_BIT(INTCLKO, INTCLKO_T1CLKO_MSK)

////////////////////////

#define AUXR_T2R_MSK                    BIT4
#define TIMER2_Run()                    SET_REG_BIT(AUXR, AUXR_T2R_MSK)
#define TIMER2_Stop()                   CLR_REG_BIT(AUXR, AUXR_T2R_MSK)

#define TIMER2_CheckFlag()              READ_REG_BIT(AUXINTIF, AUXINTIF_T2IF_MSK)
#define TIMER2_ClearFlag()              CLR_REG_BIT(AUXINTIF, AUXINTIF_T2IF_MSK)

#define TIMER2_SetReload16(n)           (T2H = HIBYTE(n), T2L = LOBYTE(n))
#define TIMER2_SetPrescale(n)           (TM2PS = (n))

#define AUXR_T2X12_MSK                  BIT2
#define TIMER2_1TMode()                 SET_REG_BIT(AUXR, AUXR_T2X12_MSK)
#define TIMER2_12TMode()                CLR_REG_BIT(AUXR, AUXR_T2X12_MSK)

#define AUXR_T2CT_MSK                   BIT3
#define TIMER2_TimerMode()              CLR_REG_BIT(AUXR, AUXR_T2CT_MSK)
#define TIMER2_CounterMode()            SET_REG_BIT(AUXR, AUXR_T2CT_MSK)

#define INTCLKO_T2CLKO_MSK              BIT2
#define TIMER2_EnableCLKO()             SET_REG_BIT(INTCLKO, INTCLKO_T2CLKO_MSK)
#define TIMER2_DisableCLKO()            CLR_REG_BIT(INTCLKO, INTCLKO_T2CLKO_MSK)

////////////////////////

#define T4T3M_T3R_MSK                   BIT3
#define TIMER3_Run()                    SET_REG_BIT(T4T3M, T4T3M_T3R_MSK)
#define TIMER3_Stop()                   CLR_REG_BIT(T4T3M, T4T3M_T3R_MSK)

#define TIMER3_CheckFlag()              READ_REG_BIT(AUXINTIF, AUXINTIF_T3IF_MSK)
#define TIMER3_ClearFlag()              CLR_REG_BIT(AUXINTIF, AUXINTIF_T3IF_MSK)

#define TIMER3_SetReload16(n)           (T3H = HIBYTE(n), T3L = LOBYTE(n))
#define TIMER3_SetPrescale(n)           (TM3PS = (n))

#define T4T3M_T3X12_MSK                 BIT1
#define TIMER3_1TMode()                 SET_REG_BIT(T4T3M, T4T3M_T3X12_MSK)
#define TIMER3_12TMode()                CLR_REG_BIT(T4T3M, T4T3M_T3X12_MSK)

#define T4T3M_T3CT_MSK                  BIT2
#define TIMER3_TimerMode()              CLR_REG_BIT(T4T3M, T4T3M_T3CT_MSK)
#define TIMER3_CounterMode()            SET_REG_BIT(T4T3M, T4T3M_T3CT_MSK)

#define T4T3M_T3CLKO_MSK                BIT0
#define TIMER3_EnableCLKO()             SET_REG_BIT(T4T3M, T4T3M_T3CLKO_MSK)
#define TIMER3_DisableCLKO()            CLR_REG_BIT(T4T3M, T4T3M_T3CLKO_MSK)

#define T3T4PIN_T3T4SEL_MSK             BIT0
#define T3T4_CLKO_SwitchP0507()         CLR_REG_BIT(T3T4PIN, T3T4PIN_T3T4SEL_MSK)
#define T3T4_CLKO_SwitchP0103()         SET_REG_BIT(T3T4PIN, T3T4PIN_T3T4SEL_MSK)

////////////////////////

#define T4T3M_T4R_MSK                   BIT7
#define TIMER4_Run()                    SET_REG_BIT(T4T3M, T4T3M_T4R_MSK)
#define TIMER4_Stop()                   CLR_REG_BIT(T4T3M, T4T3M_T4R_MSK)

#define TIMER4_CheckFlag()              READ_REG_BIT(AUXINTIF, AUXINTIF_T4IF_MSK)
#define TIMER4_ClearFlag()              CLR_REG_BIT(AUXINTIF, AUXINTIF_T4IF_MSK)

#define TIMER4_SetReload16(n)           (T4H = HIBYTE(n), T4L = LOBYTE(n))
#define TIMER4_SetPrescale(n)           (TM4PS = (n))

#define T4T3M_T4X12_MSK                 BIT5
#define TIMER4_1TMode()                 SET_REG_BIT(T4T3M, T4T3M_T4X12_MSK)
#define TIMER4_12TMode()                CLR_REG_BIT(T4T3M, T4T3M_T4X12_MSK)

#define T4T3M_T4CT_MSK                  BIT6
#define TIMER4_TimerMode()              CLR_REG_BIT(T4T3M, T4T3M_T4CT_MSK)
#define TIMER4_CounterMode()            SET_REG_BIT(T4T3M, T4T3M_T4CT_MSK)

#define T4T3M_T4CLKO_MSK                BIT4
#define TIMER4_EnableCLKO()             SET_REG_BIT(T4T3M, T4T3M_T4CLKO_MSK)
#define TIMER4_DisableCLKO()            CLR_REG_BIT(T4T3M, T4T3M_T4CLKO_MSK)

////////////////////////

#define T11CR_T11R_MSK                  BIT7
#define TIMER11_Run()                   SET_REG_BIT(T11CR, T11CR_T11R_MSK)
#define TIMER11_Stop()                  CLR_REG_BIT(T11CR, T11CR_T11R_MSK)

#define TIMER11_CheckFlag()             READ_REG_BIT(T11CR, T11CR_T11IF_MSK)
#define TIMER11_ClearFlag()             CLR_REG_BIT(T11CR, T11CR_T11IF_MSK)

#define TIMER11_SetReload16(n)          (T11H = HIBYTE(n), T11L = LOBYTE(n))
#define TIMER11_SetPrescale(n)          (T11PS = (n))

#define T11CR_T11X12_MSK                BIT4
#define TIMER11_1TMode()                SET_REG_BIT(T11CR, T11CR_T11X12_MSK)
#define TIMER11_12TMode()               CLR_REG_BIT(T11CR, T11CR_T11X12_MSK)

#define T11CR_T11CT_MSK                 BIT6
#define TIMER11_TimerMode()             CLR_REG_BIT(T11CR, T11CR_T11CT_MSK)
#define TIMER11_CounterMode()           SET_REG_BIT(T11CR, T11CR_T11CT_MSK)

#define T11CR_T11CLKO_MSK               BIT5
#define TIMER11_EnableCLKO()            SET_REG_BIT(T11CR, T11CR_T11CLKO_MSK)
#define TIMER11_DisableCLKO()           CLR_REG_BIT(T11CR, T11CR_T11CLKO_MSK)

#define T11CR_T11CS_MSK                 (BIT3 | BIT2)
#define TIMER11_ClockSource(n)          MODIFY_REG(T11CR, T11CR_T11CS_MSK, ((n) << 2))
#define TIMER11_CLK_SYSCLK()            TIMER11_ClockSource(0)
#define TIMER11_CLK_HIRC()              TIMER11_ClockSource(1)
#define TIMER11_CLK_X32K()              TIMER11_ClockSource(2)
#define TIMER11_CLK_LIRC()              TIMER11_ClockSource(3)

/////////////////////////////////////////////////

#define SCON_SM_MSK                     (BIT7 | BIT6)
#define UART1_SetMode(n)                MODIFY_REG(SCON, SCON_SM_MSK, ((n) << 6))
#define UART1_Mode0()                   UART1_SetMode(0)
#define UART1_Mode1()                   UART1_SetMode(1)
#define UART1_Mode2()                   UART1_SetMode(2)
#define UART1_Mode3()                   UART1_SetMode(3)

#define UART1_EnableRx()                (REN = 1)
#define UART1_DisableRx()               (REN = 0)
#define UART1_SetTB8(b)                 (TB8 = (b))
#define UART1_ReadRB8()                 (RB8)

#define UART1_SendData(d)               (SBUF = (d))
#define UART1_ReadData()                (SBUF)

#define PCON_SMOD_MSK                   BIT7
#define UART1_BaudrateX2()              SET_REG_BIT(PCON, PCON_SMOD_MSK)

#define AUXR_M0X6_MSK                   BIT5
#define UART1_Mode0BaudrateX6()         SET_REG_BIT(AUXR, AUXR_M0X6_MSK)

#define UR1TOCR_ENTO_MSK                BIT7
#define UART1_EnableTimeout()           SET_REG_BIT(UR1TOCR, UR1TOCR_ENTO_MSK)
#define UART1_DisableTimeout()          CLR_REG_BIT(UR1TOCR, UR1TOCR_ENTO_MSK)

#define UR1TOCR_SCALE_MSK               BIT5
#define UART1_TimeoutScale_SYSCLK()     SET_REG_BIT(UR1TOCR, UR1TOCR_SCALE_MSK)
#define UART1_TimeoutScale_BRT()        CLR_REG_BIT(UR1TOCR, UR1TOCR_SCALE_MSK)

#define UART1_SetTimeoutInterval(n)     UR1TOTL = BYTE0(n); \
                                        UR1TOTH = BYTE1(n); \
                                        UR1TOTE = BYTE2(n)

#define AUXR_S1BRT_MSK                  BIT0
#define UART1_Timer1BRT()               CLR_REG_BIT(AUXR, AUXR_S1BRT_MSK)
#define UART1_Timer2BRT()               SET_REG_BIT(AUXR, AUXR_S1BRT_MSK)

////////////////////////

#define S2CON_S2SM_MSK                  (BIT7 | BIT6)
#define UART2_SetMode(n)                MODIFY_REG(S2CON, S2CON_S2SM_MSK, ((n) << 6))
#define UART2_Mode0()                   UART2_SetMode(0)
#define UART2_Mode1()                   UART2_SetMode(1)
#define UART2_Mode2()                   UART2_SetMode(2)
#define UART2_Mode3()                   UART2_SetMode(3)

#define S2CON_S2REN_MSK                 BIT4
#define UART2_EnableRx()                SET_REG_BIT(S2CON, S2CON_S2REN_MSK)
#define UART2_DisableRx()               CLR_REG_BIT(S2CON, S2CON_S2REN_MSK)

#define S2CON_S2TB8_MSK                 BIT3
#define UART2_SetTB8(b)                 MODIFY_REG(S2CON, S2CON_S2TB8_MSK, ((b) << 3))

#define S2CON_S2RB8_MSK                 BIT2
#define UART2_ReadRB8()                 READ_REG_BIT(S2CON, S2CON_S2RB8_MSK)

#define UART2_SendData(d)               (S2BUF = (d))
#define UART2_ReadData()                (S2BUF)

#define S2CFG_S2M0X6_MSK                BIT5
#define UART2_Mode0BaudrateX6()         SET_REG_BIT(S2CFG, S2CFG_S2M0X6_MSK)

#define UR2TOCR_ENTO_MSK                BIT7
#define UART2_EnableTimeout()           SET_REG_BIT(UR2TOCR, UR2TOCR_ENTO_MSK)
#define UART2_DisableTimeout()          CLR_REG_BIT(UR2TOCR, UR2TOCR_ENTO_MSK)

#define UR2TOCR_SCALE_MSK               BIT5
#define UART2_TimeoutScale_SYSCLK()     SET_REG_BIT(UR2TOCR, UR2TOCR_SCALE_MSK)
#define UART2_TimeoutScale_BRT()        CLR_REG_BIT(UR2TOCR, UR2TOCR_SCALE_MSK)

#define UART2_SetTimeoutInterval(n)     UR2TOTL = BYTE0(n); \
                                        UR2TOTH = BYTE1(n); \
                                        UR2TOTE = BYTE2(n)

////////////////////////

#define S3CON_S3SM_MSK                  BIT7
#define UART3_SetMode(n)                MODIFY_REG(S3CON, S3CON_S3SM_MSK, ((n) << 7))
#define UART3_Mode0()                   CLR_REG_BIT(S3CON, S3CON_S3SM_MSK)
#define UART3_Mode1()                   SET_REG_BIT(S3CON, S3CON_S3SM_MSK)

#define S3CON_S3REN_MSK                 BIT4
#define UART3_EnableRx()                SET_REG_BIT(S3CON, S3CON_S3REN_MSK)
#define UART3_DisableRx()               CLR_REG_BIT(S3CON, S3CON_S3REN_MSK)

#define S3CON_S3TB8_MSK                 BIT3
#define UART3_SetTB8(b)                 MODIFY_REG(S3CON, S3CON_S3TB8_MSK, ((b) << 3))

#define S3CON_S3RB8_MSK                 BIT2
#define UART3_ReadRB8()                 READ_REG_BIT(S3CON, S3CON_S3RB8_MSK)

#define UART3_SendData(d)               (S3BUF = (d))
#define UART3_ReadData()                (S3BUF)

#define UR3TOCR_ENTO_MSK                BIT7
#define UART3_EnableTimeout()           SET_REG_BIT(UR3TOCR, UR3TOCR_ENTO_MSK)
#define UART3_DisableTimeout()          CLR_REG_BIT(UR3TOCR, UR3TOCR_ENTO_MSK)

#define UR3TOCR_SCALE_MSK               BIT5
#define UART3_TimeoutScale_SYSCLK()     SET_REG_BIT(UR3TOCR, UR3TOCR_SCALE_MSK)
#define UART3_TimeoutScale_BRT()        CLR_REG_BIT(UR3TOCR, UR3TOCR_SCALE_MSK)

#define UART3_SetTimeoutInterval(n)     UR3TOTL = BYTE0(n); \
                                        UR3TOTH = BYTE1(n); \
                                        UR3TOTE = BYTE2(n)

#define S3CON_S3BRT_MSK                 BIT0
#define UART3_Timer2BRT()               CLR_REG_BIT(S3CON, S3CON_S3BRT_MSK)
#define UART3_Timer3BRT()               SET_REG_BIT(S3CON, S3CON_S3BRT_MSK)

////////////////////////

#define S4CON_S4SM_MSK                  BIT7
#define UART4_SetMode(n)                MODIFY_REG(S4CON, S4CON_S4SM_MSK, ((n) << 7))
#define UART4_Mode0()                   CLR_REG_BIT(S4CON, S4CON_S4SM_MSK)
#define UART4_Mode1()                   SET_REG_BIT(S4CON, S4CON_S4SM_MSK)

#define S4CON_S4REN_MSK                 BIT4
#define UART4_EnableRx()                SET_REG_BIT(S4CON, S4CON_S4REN_MSK)
#define UART4_DisableRx()               CLR_REG_BIT(S4CON, S4CON_S4REN_MSK)

#define S4CON_S4TB8_MSK                 BIT3
#define UART4_SetTB8(b)                 MODIFY_REG(S4CON, S4CON_S4TB8_MSK, ((b) << 3))

#define S4CON_S4RB8_MSK                 BIT2
#define UART4_ReadRB8()                 READ_REG_BIT(S4CON, S4CON_S4RB8_MSK)

#define UART4_SendData(d)               (S4BUF = (d))
#define UART4_ReadData()                (S4BUF)

#define UR4TOCR_ENTO_MSK                BIT7
#define UART4_EnableTimeout()           SET_REG_BIT(UR4TOCR, UR4TOCR_ENTO_MSK)
#define UART4_DisableTimeout()          CLR_REG_BIT(UR4TOCR, UR4TOCR_ENTO_MSK)

#define UR4TOCR_SCALE_MSK               BIT5
#define UART4_TimeoutScale_SYSCLK()     SET_REG_BIT(UR4TOCR, UR4TOCR_SCALE_MSK)
#define UART4_TimeoutScale_BRT()        CLR_REG_BIT(UR4TOCR, UR4TOCR_SCALE_MSK)

#define UART4_SetTimeoutInterval(n)     UR4TOTL = BYTE0(n); \
                                        UR4TOTH = BYTE1(n); \
                                        UR4TOTE = BYTE2(n)

#define S4CON_S4BRT_MSK                 BIT0
#define UART4_Timer2BRT()               CLR_REG_BIT(S4CON, S4CON_S4BRT_MSK)
#define UART4_Timer4BRT()               SET_REG_BIT(S4CON, S4CON_S4BRT_MSK)

/////////////////////////////////////////////////

#define CMPCR1_CMPEN_MSK                BIT7
#define CMP_Enable()                    SET_REG_BIT(CMPCR1, CMPCR1_CMPEN_MSK)
#define CMP_Disable()                   CLR_REG_BIT(CMPCR1, CMPCR1_CMPEN_MSK)

#define CMPCR1_CMPOE_MSK                BIT1
#define CMP_EnableOutput()              SET_REG_BIT(CMPCR1, CMPCR1_CMPOE_MSK)
#define CMP_DisableOutput()             CLR_REG_BIT(CMPCR1, CMPCR1_CMPOE_MSK)

#define CMPCR1_CMPRES_MSK               BIT0
#define CMP_ReadResult()                READ_REG_BIT(CMPCR1, CMPCR1_CMPRES_MSK)

#define CMPCR2_INVO_MSK                 BIT7
#define CMP_OutputInvert()              SET_REG_BIT(CMPCR2, CMPCR2_INVO_MSK)

#define CMPCR2_DISFLT_MSK               BIT6
#define CMP_EnableAnalogFilter()        CLR_REG_BIT(CMPCR2, CMPCR2_DISFLT_MSK)
#define CMP_DisableAnalogFilter()       SET_REG_BIT(CMPCR2, CMPCR2_DISFLT_MSK)

#define CMPCR2_LCDTY_MSK                (BIT5 | BIT_LN)
#define CMP_SetDigitalFilter(n)         MODIFY_REG(CMPCR2, CMPCR2_LCDTY_MSK, ((n) << 0))

#define CMPEXCFG_CHYS_MSK               (BIT7 | BIT6)
#define CMP_SetHysteresis(n)            MODIFY_REG(CMPEXCFG, CMPEXCFG_CHYS_MSK, ((n) << 6))
#define CMP_DisableHysteresis()         CMP_SetHysteresis(0)
#define CMP_SetHysteresis_10mV()        CMP_SetHysteresis(1)
#define CMP_SetHysteresis_20mV()        CMP_SetHysteresis(2)
#define CMP_SetHysteresis_30mV()        CMP_SetHysteresis(3)

/////////////////////////////////////////////////

#define IAPCON_IAPEN_MSK                BIT7
#define IAP_Enable()                    SET_REG_BIT(IAP_CONTR, IAPCON_IAPEN_MSK)
#define IAP_Disable()                   CLR_REG_BIT(IAP_CONTR, IAPCON_IAPEN_MSK)

#define IAP_SetData(d)                  (IAP_DATA = (d))
#define IAP_ReadData()                  (IAP_DATA)

#define IAP_SetAddress(n)               IAP_ADDRL = BYTE0(n); \
                                        IAP_ADDRH = BYTE1(n); \
                                        IAP_ADDRE = BYTE2(n)

#define IAP_Trigger()                   IAP_TRIG = 0x5a; \
                                        IAP_TRIG = 0xa5; \
                                        _nop_();         \
                                        _nop_();         \
                                        _nop_();         \
                                        _nop_()

#define IAP_Idle()                      IAP_CMD = 0
#define IAP_TriggerRead()               IAP_CMD = 1; IAP_Trigger()
#define IAP_TriggerProgram()            IAP_CMD = 2; IAP_Trigger()
#define IAP_TriggerErase()              IAP_CMD = 3; IAP_Trigger()

#define IAP_SetTimeBase()               IAP_TPS = ((SYSCLK) / 1000000)

#define IAPCON_FAIL_MSK                 BIT4
#define IAP_CheckErrorFlag()            READ_REG_BIT(IAP_CONTR, IAPCON_FAIL_MSK)
#define IAP_ClearErrorFlag()            CLR_REG_BIT(IAP_CONTR, IAPCON_FAIL_MSK)

/////////////////////////////////////////////////

#define ADCCONTR_ADCPOWER_MSK           BIT7
#define ADC_Enable()                    SET_REG_BIT(ADC_CONTR, ADCCONTR_ADCPOWER_MSK)
#define ADC_Disable()                   CLR_REG_BIT(ADC_CONTR, ADCCONTR_ADCPOWER_MSK)

#define ADC_ReadResult()                MAKEWORD(ADC_RESL, ADC_RES)

#define ADCCONTR_ADCSTART_MSK           BIT6
#define ADC_Start()                     SET_REG_BIT(ADC_CONTR, ADCCONTR_ADCSTART_MSK)

#define ADCCONTR_ADCCHS_MSK             (BIT_LN)
#define ADC_ActiveChannel(n)            MODIFY_REG(ADC_CONTR, ADCCONTR_ADCCHS_MSK, ((n) << 0))

#define ADCCONTR_ADCEPWMT_MSK           BIT4
#define ADC_EnablePWMTrig()             SET_REG_BIT(ADC_CONTR, ADCCONTR_ADCEPWMT_MSK)

#define ADCCFG_RESFMT_MSK               BIT5
#define ADC_ResultLeftAlign()           CLR_REG_BIT(ADCCFG, ADCCFG_RESFMT_MSK)
#define ADC_ResultRightAlign()          SET_REG_BIT(ADCCFG, ADCCFG_RESFMT_MSK)

#define ADCCFG_SPEED_MSK                (BIT_LN)
#define ADC_SetClockDivider(n)          MODIFY_REG(ADCCFG, ADCCFG_SPEED_MSK, ((n) << 0))

#define ADCEXCFG_ETRE_MSK               BIT5
#define ADC_EnableETR()                 SET_REG_BIT(ADCEXCFG, ADCEXCFG_ETRE_MSK)
#define ADC_DisableETR()                CLR_REG_BIT(ADCEXCFG, ADCEXCFG_ETRE_MSK)

#define ADCEXCFG_ETRP_MSK               BIT4
#define ADC_ETRRising()                 CLR_REG_BIT(ADCEXCFG, ADCEXCFG_ETRP_MSK)
#define ADC_ETRFalling()                SET_REG_BIT(ADCEXCFG, ADCEXCFG_ETRP_MSK)

#define ADCEXCFG_CVT_MSK                (BIT2 | BIT1 | BIT0)
#define ADC_SetRepeatTimes(n)           MODIFY_REG(ADCEXCFG, ADCEXCFG_CVT_MSK, ((n) << 0))

#define ADC_DisableRepeatConv()         ADC_SetRepeatTimes(0)
#define ADC_SetRepeat2Times()           ADC_SetRepeatTimes(4)
#define ADC_SetRepeat4Times()           ADC_SetRepeatTimes(5)
#define ADC_SetRepeat8Times()           ADC_SetRepeatTimes(6)
#define ADC_SetRepeat16Times()          ADC_SetRepeatTimes(7)

#define ADCTIM_CSSETUP_MSK              BIT7
#define ADCTIM_CSHOLD_MSK               (BIT6 | BIT5)
#define ADCTIM_SMPDUTY_MSK              (BIT4 | BIT_LN)
#define ADC_SetCSSetupCycles(n)         MODIFY_REG(ADCTIM, ADCTIM_CSSETUP_MSK, (((n) - 1) << 7))
#define ADC_SetCSHoldCycles(n)          MODIFY_REG(ADCTIM, ADCTIM_CSHOLD_MSK, (((n) - 1) << 5))
#define ADC_SetSampleDutyCycles(n)      MODIFY_REG(ADCTIM, ADCTIM_SMPDUTY_MSK, (((n) - 1) << 0))

/////////////////////////////////////////////////

#define SPCTL_SPEN_MSK                  BIT6
#define SPI_Enable()                    SET_REG_BIT(SPCTL, SPCTL_SPEN_MSK)
#define SPI_Disable()                   CLR_REG_BIT(SPCTL, SPCTL_SPEN_MSK)

#define SPCTL_DORD_MSK                  BIT5
#define SPI_DataLSB()                   SET_REG_BIT(SPCTL, SPCTL_DORD_MSK)
#define SPI_DataMSB()                   CLR_REG_BIT(SPCTL, SPCTL_DORD_MSK)

#define SPCTL_MSTR_MSK                  BIT4
#define SPI_MasterMode()                SET_REG_BIT(SPCTL, SPCTL_MSTR_MSK)
#define SPI_SlaveMode()                 CLR_REG_BIT(SPCTL, SPCTL_MSTR_MSK)

#define SPCTL_SSIG_MSK                  BIT7
#define SPI_IgnoreSS()                  SET_REG_BIT(SPCTL, SPCTL_SSIG_MSK)
#define SPI_UnignoreSS()                CLR_REG_BIT(SPCTL, SPCTL_SSIG_MSK)

#define SPCTL_CPOL_MSK                  BIT3
#define SPCTL_CPHA_MSK                  BIT2
#define SPIMODE                         (SPCTL_CPOL_MSK | SPCTL_CPHA_MSK)
#define SPI_SetMode0()                  MODIFY_REG(SPCTL, SPIMODE, ((0) << 2))
#define SPI_SetMode1()                  MODIFY_REG(SPCTL, SPIMODE, ((1) << 2))
#define SPI_SetMode2()                  MODIFY_REG(SPCTL, SPIMODE, ((2) << 2))
#define SPI_SetMode3()                  MODIFY_REG(SPCTL, SPIMODE, ((3) << 2))

#define SPCTL_SPR_MSK                   (BIT1 | BIT0)
#define SPI_SetClockDivider(n)          MODIFY_REG(SPCTL, SPCTL_SPR_MSK, ((n) << 0))
#define SPI_SetClockDivider2()          SPI_SetClockDivider(3)
#define SPI_SetClockDivider4()          SPI_SetClockDivider(0)
#define SPI_SetClockDivider8()          SPI_SetClockDivider(1)
#define SPI_SetClockDivider16()         SPI_SetClockDivider(2)

#define SPI_SendData(d)                 (SPDAT = (d))
#define SPI_ReadData()                  (SPDAT)

#define HSSPICFG2_IOSW_MSK              BIT6
#define SPI_SwapMosiMiso()              SET_REG_BIT(HSSPI_CFG2, HSSPICFG2_IOSW_MSK)

#define HSSPICFG2_HSSPIEN_MSK           BIT5
#define HSSPI_Enable()                  SET_REG_BIT(HSSPI_CFG2, HSSPICFG2_HSSPIEN_MSK)
#define HSSPI_Disable()                 CLR_REG_BIT(HSSPI_CFG2, HSSPICFG2_HSSPIEN_MSK)

#define HSSPICFG_SSHLD_MSK              BIT_HN
#define HSSPI_SetSSHoldTime(n)          MODIFY_REG(HSSPI_CFG, HSSPICFG_SSHLD_MSK, ((n) << 4))

#define HSSPICFG_SSSETUP_MSK            BIT_LN
#define HSSPI_SetSSSetupTime(n)         MODIFY_REG(HSSPI_CFG, HSSPICFG_SSSETUP_MSK, ((n) << 0))

#define HSSPICFG2_SSDACT_MSK            BIT_LN
#define HSSPI_SetSSDeactTime(n)         MODIFY_REG(HSSPI_CFG2, HSSPICFG2_SSDACT_MSK, ((n) << 0))

#define HSSPICFG2_FIFOEN_MSK            BIT4
#define HSSPI_EnableFIFO()              SET_REG_BIT(HSSPI_CFG2, HSSPICFG2_FIFOEN_MSK)
#define HSSPI_DisableFIFO()             CLR_REG_BIT(HSSPI_CFG2, HSSPICFG2_FIFOEN_MSK)

#define HSSPI_SetClockDivider(n)        WRITE_REG(HSSPI_PSCR, (n))

#define SPITOCR_ENTO_MSK                BIT7
#define SPI_EnableTimeout()             SET_REG_BIT(SPITOCR, SPITOCR_ENTO_MSK)
#define SPI_DisableTimeout()            CLR_REG_BIT(SPITOCR, SPITOCR_ENTO_MSK)

#define SPITOCR_SCALE_MSK               BIT5
#define SPI_TimeoutScale_SYSCLK()       SET_REG_BIT(SPITOCR, SPITOCR_SCALE_MSK)
#define SPI_TimeoutScale_1us()          CLR_REG_BIT(SPITOCR, SPITOCR_SCALE_MSK)

#define SPI_SetTimeoutInterval(n)       SPITOTL = BYTE0(n); \
                                        SPITOTH = BYTE1(n); \
                                        SPITOTE = BYTE2(n)

/////////////////////////////////////////////////

#define I2CCFG_ENI2C_MSK                BIT7
#define I2C_Enable()                    SET_REG_BIT(I2CCFG, I2CCFG_ENI2C_MSK)
#define I2C_Disable()                   CLR_REG_BIT(I2CCFG, I2CCFG_ENI2C_MSK)

#define I2CCFG_MSSL_MSK                 BIT6
#define I2C_MasterMode()                SET_REG_BIT(I2CCFG, I2CCFG_MSSL_MSK)
#define I2C_SlaveMode()                 CLR_REG_BIT(I2CCFG, I2CCFG_MSSL_MSK)

#define I2CCFG_SPEED_MSK                (BIT5 | BIT4 |BIT_LN)
#define I2C_SetClockDivider(n)          MODIFY_REG(I2CCFG, I2CCFG_SPEED_MSK, ((n) << 0)); \
                                        I2CPSCR = ((n) >> 6)

#define I2CMSCR_MSCMD_MSK               (BIT_LN)
#define I2C_SetMasterCommand(n)         MODIFY_REG(I2CMSCR, I2CMSCR_MSCMD_MSK, ((n) << 0))

#define I2CCMD_IDLE                     0
#define I2CCMD_START                    1
#define I2CCMD_SENDDATA                 2
#define I2CCMD_RECVACK                  3
#define I2CCMD_RECVDATA                 4
#define I2CCMD_SENDACK                  5
#define I2CCMD_STOP                     6
#define I2CCMD_START_SENDDATA_RECVACK   9
#define I2CCMD_SENDDATA_RECVACK         10
#define I2CCMD_RECVDATA_SENDACK         11
#define I2CCMD_RECVDATA_SENDNAK         12
#define I2C_Idle()                      I2C_SetMasterCommand(I2CCMD_IDLE)
#define I2C_Start()                     I2C_SetMasterCommand(I2CCMD_START)
#define I2C_SendData()                  I2C_SetMasterCommand(I2CCMD_SENDDATA)
#define I2C_RecvACK()                   I2C_SetMasterCommand(I2CCMD_RECVACK)
#define I2C_RecvData()                  I2C_SetMasterCommand(I2CCMD_RECVDATA)
#define I2C_SendACK()                   I2C_SetMasterCommand(I2CCMD_SENDACK)
#define I2C_Stop()                      I2C_SetMasterCommand(I2CCMD_STOP)
#define I2C_StartSendDataRecvACK()      I2C_SetMasterCommand(I2CCMD_START_SENDDATA_RECVACK)
#define I2C_SendDataRecvACK()           I2C_SetMasterCommand(I2CCMD_SENDDATA_RECVACK)
#define I2C_RecvDataSendACK()           I2C_SetMasterCommand(I2CCMD_RECVDATA_SENDACK)
#define I2C_RecvDataSendNAK()           I2C_SetMasterCommand(I2CCMD_RECVDATA_SENDNA)

#define I2CMSST_BUSY_MSK                BIT7
#define I2C_CheckMasterBusy()           READ_REG_BIT(I2CMSST, I2CMSST_BUSY_MSK)

#define I2CMSST_MSIF_MSK                BIT6
#define I2C_CheckMasterFlag()           READ_REG_BIT(I2CMSST, I2CMSST_MSIF_MSK)
#define I2C_ClearMasterFlag()           CLR_REG_BIT(I2CMSST, I2CMSST_MSIF_MSK)

#define I2C_WriteData(d)                (I2CTXD = (d))
#define I2C_ReadData()                  (I2CRXD)

#define I2CMSST_ACKI_MSK                BIT1
#define I2CMSST_ACKO_MSK                BIT0
#define I2C_MasterSetACK()              CLR_REG_BIT(I2CMSST, I2CMSST_ACKO_MSK)
#define I2C_MasterSetNAK()              SET_REG_BIT(I2CMSST, I2CMSST_ACKO_MSK)
#define I2C_MasterReadACK()             READ_REG_BIT(I2CMSST, I2CMSST_ACKI_MSK)

#define I2CSLCR_SLRST_MSK               BIT0
#define I2C_SlaveReset()                SET_REG_BIT(I2CSLCR, I2CSLCR_SLRST_MSK)

#define I2CSLST_BUSY_MSK                BIT7
#define I2C_CheckSlaveBusy()            READ_REG_BIT(I2CSLST, I2CSLST_BUSY_MSK)

#define I2CSLST_ACKI_MSK                BIT1
#define I2CSLST_ACKO_MSK                BIT0
#define I2C_SlaveSetACK()               CLR_REG_BIT(I2CSLST, I2CSLST_ACKO_MSK)
#define I2C_SlaveSetNAK()               SET_REG_BIT(I2CSLST, I2CSLST_ACKO_MSK)
#define I2C_SlaveReadACK()              READ_REG_BIT(I2CSLST, I2CSLST_ACKI_MSK)

#define I2CSLADR_SLADR_MSK              (BIT_HN | BIT3 | BIT2 | BIT1)
#define I2C_SetSlaveAddress(n)          I2CSLADR = ((n) << 1)

#define I2CSLADR_MA_MSK                 (BIT0)
#define I2C_SetSlaveBroadcast()         SET_REG_BIT(I2CSLADR, I2CSLADR_MA_MSK)

#define I2CTOCR_ENTO_MSK                BIT7
#define I2C_EnableTimeout()             SET_REG_BIT(I2CTOCR, I2CTOCR_ENTO_MSK)
#define I2C_DisableTimeout()            CLR_REG_BIT(I2CTOCR, I2CTOCR_ENTO_MSK)

#define I2CTOCR_SCALE_MSK               BIT5
#define I2C_TimeoutScale_SYSCLK()       SET_REG_BIT(I2CTOCR, I2CTOCR_SCALE_MSK)
#define I2C_TimeoutScale_1us()          CLR_REG_BIT(I2CTOCR, I2CTOCR_SCALE_MSK)

#define I2C_SetTimeoutInterval(n)       I2CTOTL = BYTE0(n); \
                                        I2CTOTH = BYTE1(n); \
                                        I2CTOTE = BYTE2(n)

/////////////////////////////////////////////////

#define RTCCR_RUNRTC_MSK                BIT0
#define RTC_Run()                       SET_REG_BIT(RTCCR, RTCCR_RUNRTC_MSK)
#define RTC_Stop()                      CLR_REG_BIT(RTCCR, RTCCR_RUNRTC_MSK)

#define RTCCFG_RTCCKS_MSK               BIT1
#define RTC_CLK_X32K()                  CLR_REG_BIT(RTCCFG, RTCCFG_RTCCKS_MSK)
#define RTC_CLK_LIRC()                  SET_REG_BIT(RTCCFG, RTCCFG_RTCCKS_MSK)

#define RTCCFG_SETRTC_MSK               BIT0
#define RTC_SyncInitial()               SET_REG_BIT(RTCCFG, RTCCFG_SETRTC_MSK)
#define RTC_IsSyncing()                 READ_REG_BIT(RTCCFG, RTCCFG_SETRTC_MSK)

#define RTC_SetAlarmHour(n)             (ALAHOUR = (n))
#define RTC_SetAlarmMinute(n)           (ALAMIN = (n))
#define RTC_SetAlarmSecond(n)           (ALASEC = (n))
#define RTC_SetAlarmSSecond(n)          (ALASSEC = (n))

#define RTC_SetYear(n)                  (INIYEAR = (n))
#define RTC_SetMonth(n)                 (INIMONTH = (n))
#define RTC_SetDay(n)                   (INIDAY = (n))
#define RTC_SetHour(n)                  (INIHOUR = (n))
#define RTC_SetMinute(n)                (INIMIN = (n))
#define RTC_SetSecond(n)                (INISEC = (n))
#define RTC_SetSSecond(n)               (INISSEC = (n))

#define RTC_ReadYear()                  (YEAR)
#define RTC_ReadMonth()                 (MONTH)
#define RTC_ReadDay()                   (DAY)
#define RTC_ReadHour()                  (HOUR)
#define RTC_ReadMinute()                (MIN)
#define RTC_ReadSecond()                (SEC)
#define RTC_ReadSSecond()               (SSEC)

/////////////////////////////////////////////////

#define LCMIFCR_EN_MSK                  BIT7
#define LCM_Enable()                    SET_REG_BIT(LCMIFCR, LCMIFCR_EN_MSK)
#define LCM_Disable()                   CLR_REG_BIT(LCMIFCR, LCMIFCR_EN_MSK)

#define LCMIFCFG_BW_MSK                 BIT1
#define LCM_SetBitWidth_8B()            CLR_REG_BIT(LCMIFCFG, LCMIFCFG_BW_MSK)
#define LCM_SetBitWidth_16B()           SET_REG_BIT(LCMIFCFG, LCMIFCFG_BW_MSK)

#define LCMIFCFG_MODE_MSK               BIT0
#define LCM_SetMode_i8080()             CLR_REG_BIT(LCMIFCFG, LCMIFCFG_MODE_MSK)
#define LCM_SetMode_M6800()             SET_REG_BIT(LCMIFCFG, LCMIFCFG_MODE_MSK)

#define LCMIFCFG2_SETUPT_MSK            (BIT4 | BIT3 | BIT2)
#define LCMIFCFG2_HOLDT_MSK             (BIT1 | BIT0)
#define LCM_SetSetupTime(n)             MODIFY_REG(LCMIFCFG2, LCMIFCFG2_SETUPT_MSK, ((n) << 2))
#define LCM_SetHoldTime(n)              MODIFY_REG(LCMIFCFG2, LCMIFCFG2_HOLDT_MSK, ((n) << 0))

#define LCMIFCR_ENDIAN_MSK              BIT4
#define LCM_SetDataBigEndian()          CLR_REG_BIT(LCMIFCR, LCMIFCR_ENDIAN_MSK)
#define LCM_SetDataLittleEndian()       SET_REG_BIT(LCMIFCR, LCMIFCR_ENDIAN_MSK)

#define LCMIFCR_CMD_MSK                 (BIT2 | BIT1 | BIT0)
#define LCM_SetCommand(n)               MODIFY_REG(LCMIFCR, LCMIFCR_CMD_MSK, ((n) << 0))

#define LCMCMD_IDLE                     0
#define LCMCMD_SENDCMD                  4
#define LCMCMD_SENDDATA                 5
#define LCMCMD_READSTAT                 6
#define LCMCMD_READDATA                 7
#define LCM_Idle()                      LCM_SetCommand(LCMCMD_IDLE)
#define LCM_TrigSendCommand()           LCM_SetCommand(LCMCMD_SENDCMD)
#define LCM_TrigSendData()              LCM_SetCommand(LCMCMD_SENDDATA)
#define LCM_TrigReadStatus()            LCM_SetCommand(LCMCMD_READSTAT)
#define LCM_TrigReadData()              LCM_SetCommand(LCMCMD_READDATA)

#define LCM_WriteData_8B(d)             WRITE_REG(LCMIFDATL, (d))
#define LCM_ReadData_8B()               (LCMIFDATL)

#define LCM_WriteData_16B(d)            (LCMIFDATH = HIBYTE(d), LCMIFDATL = LOBYTE(d))
#define LCM_ReadData_16B()              MAKEWORD(LCMIFDATL, LCMIFDATH)

#define LCM_SetClockDivider(n)          WRITE_REG(LCMIFPSCR, (n))

/////////////////////////////////////////////////

#define TFPU_CLK_SYSCLK()               WRITE_REG(DMAIR, (0x3e))
#define TFPU_CLK_HSIOCK()               WRITE_REG(DMAIR, (0x3f))

/////////////////////////////////////////////////

#define DMAUR1TCFG_UR1TPTY_MSK          (BIT1 | BIT0)
#define DMAUR2TCFG_UR2TPTY_MSK          (BIT1 | BIT0)
#define DMAUR3TCFG_UR3TPTY_MSK          (BIT1 | BIT0)
#define DMAUR4TCFG_UR4TPTY_MSK          (BIT1 | BIT0)
#define DMA_UART1_SetTxBusPriority(n)   MODIFY_REG(DMA_UR1T_CFG,  DMAUR1TCFG_UR1TPTY_MSK, ((n) << 0))
#define DMA_UART2_SetTxBusPriority(n)   MODIFY_REG(DMA_UR2T_CFG,  DMAUR2TCFG_UR2TPTY_MSK, ((n) << 0))
#define DMA_UART3_SetTxBusPriority(n)   MODIFY_REG(DMA_UR3T_CFG,  DMAUR3TCFG_UR3TPTY_MSK, ((n) << 0))
#define DMA_UART4_SetTxBusPriority(n)   MODIFY_REG(DMA_UR4T_CFG,  DMAUR4TCFG_UR4TPTY_MSK, ((n) << 0))

#define DMAUR1RCFG_UR1RPTY_MSK          (BIT1 | BIT0)
#define DMAUR2RCFG_UR2RPTY_MSK          (BIT1 | BIT0)
#define DMAUR3RCFG_UR3RPTY_MSK          (BIT1 | BIT0)
#define DMAUR4RCFG_UR4RPTY_MSK          (BIT1 | BIT0)
#define DMA_UART1_SetRxBusPriority(n)   MODIFY_REG(DMA_UR1R_CFG,  DMAUR1RCFG_UR1RPTY_MSK, ((n) << 0))
#define DMA_UART2_SetRxBusPriority(n)   MODIFY_REG(DMA_UR2R_CFG,  DMAUR2RCFG_UR2RPTY_MSK, ((n) << 0))
#define DMA_UART3_SetRxBusPriority(n)   MODIFY_REG(DMA_UR3R_CFG,  DMAUR3RCFG_UR3RPTY_MSK, ((n) << 0))
#define DMA_UART4_SetRxBusPriority(n)   MODIFY_REG(DMA_UR4R_CFG,  DMAUR4RCFG_UR4RPTY_MSK, ((n) << 0))

#define DMAUR1TCR_ENUR1T_MSK            BIT7
#define DMAUR2TCR_ENUR2T_MSK            BIT7
#define DMAUR3TCR_ENUR3T_MSK            BIT7
#define DMAUR4TCR_ENUR4T_MSK            BIT7
#define DMA_UART1_EnableTx()            SET_REG_BIT(DMA_UR1T_CR, DMAUR1TCR_ENUR1T_MSK)
#define DMA_UART2_EnableTx()            SET_REG_BIT(DMA_UR2T_CR, DMAUR2TCR_ENUR2T_MSK)
#define DMA_UART3_EnableTx()            SET_REG_BIT(DMA_UR3T_CR, DMAUR3TCR_ENUR3T_MSK)
#define DMA_UART4_EnableTx()            SET_REG_BIT(DMA_UR4T_CR, DMAUR4TCR_ENUR4T_MSK)
#define DMA_UART1_DisableTx()           CLR_REG_BIT(DMA_UR1T_CR, DMAUR1TCR_ENUR1T_MSK)
#define DMA_UART2_DisableTx()           CLR_REG_BIT(DMA_UR2T_CR, DMAUR2TCR_ENUR2T_MSK)
#define DMA_UART3_DisableTx()           CLR_REG_BIT(DMA_UR3T_CR, DMAUR3TCR_ENUR3T_MSK)
#define DMA_UART4_DisableTx()           CLR_REG_BIT(DMA_UR4T_CR, DMAUR4TCR_ENUR4T_MSK)

#define DMAUR1RCR_ENUR1R_MSK            BIT7
#define DMAUR2RCR_ENUR2R_MSK            BIT7
#define DMAUR3RCR_ENUR3R_MSK            BIT7
#define DMAUR4RCR_ENUR4R_MSK            BIT7
#define DMA_UART1_EnableRx()            SET_REG_BIT(DMA_UR1R_CR, DMAUR1RCR_ENUR1R_MSK)
#define DMA_UART2_EnableRx()            SET_REG_BIT(DMA_UR2R_CR, DMAUR2RCR_ENUR2R_MSK)
#define DMA_UART3_EnableRx()            SET_REG_BIT(DMA_UR3R_CR, DMAUR3RCR_ENUR3R_MSK)
#define DMA_UART4_EnableRx()            SET_REG_BIT(DMA_UR4R_CR, DMAUR4RCR_ENUR4R_MSK)
#define DMA_UART1_DisableRx()           CLR_REG_BIT(DMA_UR1R_CR, DMAUR1RCR_ENUR1R_MSK)
#define DMA_UART2_DisableRx()           CLR_REG_BIT(DMA_UR2R_CR, DMAUR2RCR_ENUR2R_MSK)
#define DMA_UART3_DisableRx()           CLR_REG_BIT(DMA_UR3R_CR, DMAUR3RCR_ENUR3R_MSK)
#define DMA_UART4_DisableRx()           CLR_REG_BIT(DMA_UR4R_CR, DMAUR4RCR_ENUR4R_MSK)

#define DMAUR1TCR_TRIG_MSK              BIT6
#define DMAUR2TCR_TRIG_MSK              BIT6
#define DMAUR3TCR_TRIG_MSK              BIT6
#define DMAUR4TCR_TRIG_MSK              BIT6
#define DMA_UART1_TriggerTx()           SET_REG_BIT(DMA_UR1T_CR, DMAUR1TCR_TRIG_MSK)
#define DMA_UART2_TriggerTx()           SET_REG_BIT(DMA_UR2T_CR, DMAUR2TCR_TRIG_MSK)
#define DMA_UART3_TriggerTx()           SET_REG_BIT(DMA_UR3T_CR, DMAUR3TCR_TRIG_MSK)
#define DMA_UART4_TriggerTx()           SET_REG_BIT(DMA_UR4T_CR, DMAUR4TCR_TRIG_MSK)

#define DMAUR1RCR_TRIG_MSK              BIT5
#define DMAUR2RCR_TRIG_MSK              BIT5
#define DMAUR3RCR_TRIG_MSK              BIT5
#define DMAUR4RCR_TRIG_MSK              BIT5
#define DMA_UART1_TriggerRx()           SET_REG_BIT(DMA_UR1R_CR, DMAUR1RCR_TRIG_MSK)
#define DMA_UART2_TriggerRx()           SET_REG_BIT(DMA_UR2R_CR, DMAUR2RCR_TRIG_MSK)
#define DMA_UART3_TriggerRx()           SET_REG_BIT(DMA_UR3R_CR, DMAUR3RCR_TRIG_MSK)
#define DMA_UART4_TriggerRx()           SET_REG_BIT(DMA_UR4R_CR, DMAUR4RCR_TRIG_MSK)

#define DMAUR1RCR_CLRFIFO_MSK           BIT0
#define DMAUR2RCR_CLRFIFO_MSK           BIT0
#define DMAUR3RCR_CLRFIFO_MSK           BIT0
#define DMAUR4RCR_CLRFIFO_MSK           BIT0
#define DMA_UART1_ClearFIFO()           SET_REG_BIT(DMA_UR1R_CR, DMAUR1RCR_CLRFIFO_MSK)
#define DMA_UART2_ClearFIFO()           SET_REG_BIT(DMA_UR2R_CR, DMAUR2RCR_CLRFIFO_MSK)
#define DMA_UART3_ClearFIFO()           SET_REG_BIT(DMA_UR3R_CR, DMAUR3RCR_CLRFIFO_MSK)
#define DMA_UART4_ClearFIFO()           SET_REG_BIT(DMA_UR4R_CR, DMAUR4RCR_CLRFIFO_MSK)

#define DMAUR1TSTA_TXOVW_MSK            BIT2
#define DMAUR2TSTA_TXOVW_MSK            BIT2
#define DMAUR3TSTA_TXOVW_MSK            BIT2
#define DMAUR4TSTA_TXOVW_MSK            BIT2
#define DMA_UART1_CheckOverWriteFlag()  READ_REG_BIT(DMA_UR1T_STA,  DMAUR1TSTA_TXOVW_MSK)
#define DMA_UART2_CheckOverWriteFlag()  READ_REG_BIT(DMA_UR2T_STA,  DMAUR2TSTA_TXOVW_MSK)
#define DMA_UART3_CheckOverWriteFlag()  READ_REG_BIT(DMA_UR3T_STA,  DMAUR3TSTA_TXOVW_MSK)
#define DMA_UART4_CheckOverWriteFlag()  READ_REG_BIT(DMA_UR4T_STA,  DMAUR4TSTA_TXOVW_MSK)
#define DMA_UART1_ClearOverWriteFlag()  CLR_REG_BIT(DMA_UR1T_STA,   DMAUR1TSTA_TXOVW_MSK)
#define DMA_UART2_ClearOverWriteFlag()  CLR_REG_BIT(DMA_UR2T_STA,   DMAUR2TSTA_TXOVW_MSK)
#define DMA_UART3_ClearOverWriteFlag()  CLR_REG_BIT(DMA_UR3T_STA,   DMAUR3TSTA_TXOVW_MSK)
#define DMA_UART4_ClearOverWriteFlag()  CLR_REG_BIT(DMA_UR4T_STA,   DMAUR4TSTA_TXOVW_MSK)

#define DMAUR1RSTA_RXLOSS_MSK           BIT1
#define DMAUR2RSTA_RXLOSS_MSK           BIT1
#define DMAUR3RSTA_RXLOSS_MSK           BIT1
#define DMAUR4RSTA_RXLOSS_MSK           BIT1
#define DMA_UART1_CheckRxLossFlag()     READ_REG_BIT(DMA_UR1R_STA,  DMAUR1RSTA_RXLOSS_MSK)
#define DMA_UART2_CheckRxLossFlag()     READ_REG_BIT(DMA_UR2R_STA,  DMAUR2RSTA_RXLOSS_MSK)
#define DMA_UART3_CheckRxLossFlag()     READ_REG_BIT(DMA_UR3R_STA,  DMAUR3RSTA_RXLOSS_MSK)
#define DMA_UART4_CheckRxLossFlag()     READ_REG_BIT(DMA_UR4R_STA,  DMAUR4RSTA_RXLOSS_MSK)
#define DMA_UART1_ClearRxLossFlag()     CLR_REG_BIT(DMA_UR1R_STA,   DMAUR1RSTA_RXLOSS_MSK)
#define DMA_UART2_ClearRxLossFlag()     CLR_REG_BIT(DMA_UR2R_STA,   DMAUR2RSTA_RXLOSS_MSK)
#define DMA_UART3_ClearRxLossFlag()     CLR_REG_BIT(DMA_UR3R_STA,   DMAUR3RSTA_RXLOSS_MSK)
#define DMA_UART4_ClearRxLossFlag()     CLR_REG_BIT(DMA_UR4R_STA,   DMAUR4RSTA_RXLOSS_MSK)

#define DMA_UART1_SetTxAmount(d)        (DMA_UR1T_AMTH = HIBYTE(d), DMA_UR1T_AMT = LOBYTE(d))
#define DMA_UART2_SetTxAmount(d)        (DMA_UR2T_AMTH = HIBYTE(d), DMA_UR2T_AMT = LOBYTE(d))
#define DMA_UART3_SetTxAmount(d)        (DMA_UR3T_AMTH = HIBYTE(d), DMA_UR3T_AMT = LOBYTE(d))
#define DMA_UART4_SetTxAmount(d)        (DMA_UR4T_AMTH = HIBYTE(d), DMA_UR4T_AMT = LOBYTE(d))

#define DMA_UART1_SetRxAmount(d)        (DMA_UR1R_AMTH = HIBYTE(d), DMA_UR1R_AMT = LOBYTE(d))
#define DMA_UART2_SetRxAmount(d)        (DMA_UR2R_AMTH = HIBYTE(d), DMA_UR2R_AMT = LOBYTE(d))
#define DMA_UART3_SetRxAmount(d)        (DMA_UR3R_AMTH = HIBYTE(d), DMA_UR3R_AMT = LOBYTE(d))
#define DMA_UART4_SetRxAmount(d)        (DMA_UR4R_AMTH = HIBYTE(d), DMA_UR4R_AMT = LOBYTE(d))

#define DMA_UART1_ReadTxDone()          MAKEWORD(DMA_UR1T_DONE, DMA_UR1T_DONEH)
#define DMA_UART2_ReadTxDone()          MAKEWORD(DMA_UR2T_DONE, DMA_UR2T_DONEH)
#define DMA_UART3_ReadTxDone()          MAKEWORD(DMA_UR3T_DONE, DMA_UR3T_DONEH)
#define DMA_UART4_ReadTxDone()          MAKEWORD(DMA_UR4T_DONE, DMA_UR4T_DONEH)
                               
#define DMA_UART1_ReadRxDone()          MAKEWORD(DMA_UR1R_DONE, DMA_UR1R_DONEH)
#define DMA_UART2_ReadRxDone()          MAKEWORD(DMA_UR2R_DONE, DMA_UR2R_DONEH)
#define DMA_UART3_ReadRxDone()          MAKEWORD(DMA_UR3R_DONE, DMA_UR3R_DONEH)
#define DMA_UART4_ReadRxDone()          MAKEWORD(DMA_UR4R_DONE, DMA_UR4R_DONEH)

#define DMA_UART1_SetTxAddress(d)       (DMA_UR1T_TXAH = HIBYTE(d), DMA_UR1T_TXAL = LOBYTE(d))
#define DMA_UART2_SetTxAddress(d)       (DMA_UR2T_TXAH = HIBYTE(d), DMA_UR2T_TXAL = LOBYTE(d))
#define DMA_UART3_SetTxAddress(d)       (DMA_UR3T_TXAH = HIBYTE(d), DMA_UR3T_TXAL = LOBYTE(d))
#define DMA_UART4_SetTxAddress(d)       (DMA_UR4T_TXAH = HIBYTE(d), DMA_UR4T_TXAL = LOBYTE(d))

#define DMA_UART1_SetRxAddress(d)       (DMA_UR1R_RXAH = HIBYTE(d), DMA_UR1R_RXAL = LOBYTE(d))
#define DMA_UART2_SetRxAddress(d)       (DMA_UR2R_RXAH = HIBYTE(d), DMA_UR2R_RXAL = LOBYTE(d))
#define DMA_UART3_SetRxAddress(d)       (DMA_UR3R_RXAH = HIBYTE(d), DMA_UR3R_RXAL = LOBYTE(d))
#define DMA_UART4_SetRxAddress(d)       (DMA_UR4R_RXAH = HIBYTE(d), DMA_UR4R_RXAL = LOBYTE(d))

/////////////////////////////////////////////////

#define DMAADCCFG_ADCPTY_MSK            (BIT1 | BIT0)
#define DMA_ADC_SetBusPriority(n)       MODIFY_REG(DMA_ADC_CFG,  DMAADCCFG_ADCPTY_MSK, ((n) << 0))

#define DMAADCCR_ENADC_MSK              BIT7
#define DMA_ADC_Enable()                SET_REG_BIT(DMA_ADC_CR, DMAADCCR_ENADC_MSK)
#define DMA_ADC_Disable()               CLR_REG_BIT(DMA_ADC_CR, DMAADCCR_ENADC_MSK)

#define DMAADCCR_TRIG_MSK               BIT6
#define DMA_ADC_Trigger()               SET_REG_BIT(DMA_ADC_CR, DMAADCCR_TRIG_MSK)

#define DMA_ADC_SetAmount(d)            (DMA_ADC_AMTH = HIBYTE(d), DMA_ADC_AMT = LOBYTE(d))
#define DMA_ADC_ReadDone()              MAKEWORD(DMA_ADC_DONE, DMA_ADC_DONEH)
#define DMA_ADC_SetAddress(d)           (DMA_ADC_RXAH = HIBYTE(d), DMA_ADC_RXAL = LOBYTE(d))
#define DMA_ADC_SetChannels(d)          (DMA_ADC_CHSW1 = HIBYTE(d), DMA_ADC_CHSW0 = LOBYTE(d))

/////////////////////////////////////////////////

#define DMASPICFG_ACTTX_MSK             BIT6
#define DMASPICFG_ACTRX_MSK             BIT5
#define DMA_SPI_EnableTx()              SET_REG_BIT(DMA_SPI_CFG, DMASPICFG_ACTTX_MSK)
#define DMA_SPI_DisableTx()             CLR_REG_BIT(DMA_SPI_CFG, DMASPICFG_ACTTX_MSK)
#define DMA_SPI_EnableRx()              SET_REG_BIT(DMA_SPI_CFG, DMASPICFG_ACTRX_MSK)
#define DMA_SPI_DisableRx()             CLR_REG_BIT(DMA_SPI_CFG, DMASPICFG_ACTRX_MSK)

#define DMASPICFG_SPIPTY_MSK            (BIT1 | BIT0)
#define DMA_SPI_SetBusPriority(n)       MODIFY_REG(DMA_SPI_CFG,  DMASPICFG_SPIPTY_MSK, ((n) << 0))

#define DMASPICFG2_WRPSS_MSK            BIT2
#define DMA_SPI_AutoSS()                SET_REG_BIT(DMA_SPI_CFG2, DMASPICFG2_WRPSS_MSK)
#define DMA_SPI_ManualSS()              CLR_REG_BIT(DMA_SPI_CFG2, DMASPICFG2_WRPSS_MSK)

#define DMASPICFG2_SSS_MSK              (BIT1 | BIT0)
#define DMA_SPI_SetAutoSSPort(n)        MODIFY_REG(DMA_SPI_CFG2,  DMASPICFG2_SSS_MSK, ((n) << 0))
#define DMA_SPI_SetAutoSSP14()          DMA_SPI_SetAutoSSPort(0)
#define DMA_SPI_SetAutoSSP24()          DMA_SPI_SetAutoSSPort(1)
#define DMA_SPI_SetAutoSSP40()          DMA_SPI_SetAutoSSPort(2)
#define DMA_SPI_SetAutoSSP35()          DMA_SPI_SetAutoSSPort(3)

#define DMASPICR_ENSPI_MSK              BIT7
#define DMA_SPI_Enable()                SET_REG_BIT(DMA_SPI_CR, DMASPICR_ENSPI_MSK)
#define DMA_SPI_Disable()               CLR_REG_BIT(DMA_SPI_CR, DMASPICR_ENSPI_MSK)

#define DMASPICR_TRIGM_MSK              BIT6
#define DMASPICR_TRIGS_MSK              BIT5
#define DMA_SPI_MasterTrigger()         SET_REG_BIT(DMA_SPI_CR, DMASPICR_TRIGM_MSK)
#define DMA_SPI_SlaveTrigger()          SET_REG_BIT(DMA_SPI_CR, DMASPICR_TRIGS_MSK)

#define DMASPICR_CLRFIFO_MSK            BIT0
#define DMA_SPI_ClearFIFO()             SET_REG_BIT(DMA_SPI_CR, DMASPICR_CLRFIFO_MSK)

#define DMASPISTA_TXOVW_MSK             BIT2
#define DMASPISTA_RXLOSS_MSK            BIT1
#define DMA_SPI_CheckOverWriteFlag()    READ_REG_BIT(DMA_SPI_STA,  DMASPISTA_TXOVW_MSK)
#define DMA_SPI_ClearOverWriteFlag()    CLR_REG_BIT(DMA_SPI_STA,   DMASPISTA_TXOVW_MSK)
#define DMA_SPI_CheckRxLossFlag()       READ_REG_BIT(DMA_SPI_STA,  DMASPISTA_RXLOSS_MSK)
#define DMA_SPI_ClearRxLossFlag()       CLR_REG_BIT(DMA_SPI_STA,   DMASPISTA_RXLOSS_MSK)

#define DMA_SPI_SetAmount(d)            (DMA_SPI_AMTH = HIBYTE(d), DMA_SPI_AMT = LOBYTE(d))
#define DMA_SPI_ReadDone()              MAKEWORD(DMA_SPI_DONE, DMA_SPI_DONEH)
#define DMA_SPI_SetTxAddress(d)         (DMA_SPI_TXAH = HIBYTE(d), DMA_SPI_TXAL = LOBYTE(d))
#define DMA_SPI_SetRxAddress(d)         (DMA_SPI_RXAH = HIBYTE(d), DMA_SPI_RXAL = LOBYTE(d))

/////////////////////////////////////////////////

#define DMALCMCFG_LCMPTY_MSK            (BIT1 | BIT0)
#define DMA_LCM_SetBusPriority(n)       MODIFY_REG(DMA_LCM_CFG,  DMALCMCFG_LCMPTY_MSK, ((n) << 0))

#define DMALCMCR_ENLCM_MSK              BIT7
#define DMA_LCM_Enable()                SET_REG_BIT(DMA_LCM_CR, DMALCMCR_ENLCM_MSK)
#define DMA_LCM_Disable()               CLR_REG_BIT(DMA_LCM_CR, DMALCMCR_ENLCM_MSK)

#define DMALCMCR_TRIGWC_MSK             BIT6
#define DMALCMCR_TRIGWD_MSK             BIT5
#define DMALCMCR_TRIGRC_MSK             BIT4
#define DMALCMCR_TRIGRD_MSK             BIT3
#define DMA_LCM_TriggerWriteCommand()   SET_REG_BIT(DMA_LCM_CR, DMALCMCR_TRIGWC_MSK)
#define DMA_LCM_TriggerWriteData()      SET_REG_BIT(DMA_LCM_CR, DMALCMCR_TRIGWD_MSK)
#define DMA_LCM_TriggerReadStatus()     SET_REG_BIT(DMA_LCM_CR, DMALCMCR_TRIGRC_MSK)
#define DMA_LCM_TriggerReadData()       SET_REG_BIT(DMA_LCM_CR, DMALCMCR_TRIGRD_MSK)

#define DMALCMSTA_TXOVW_MSK             BIT1
#define DMA_LCM_CheckOverWriteFlag()    READ_REG_BIT(DMA_LCM_STA,  DMALCMSTA_TXOVW_MSK)
#define DMA_LCM_ClearOverWriteFlag()    CLR_REG_BIT(DMA_LCM_STA,   DMALCMSTA_TXOVW_MSK)

#define DMA_LCM_SetAmount(d)            (DMA_LCM_AMTH = HIBYTE(d), DMA_LCM_AMT = LOBYTE(d))
#define DMA_LCM_ReadDone()              MAKEWORD(DMA_LCM_DONE, DMA_LCM_DONEH)
#define DMA_LCM_SetTxAddress(d)         (DMA_LCM_TXAH = HIBYTE(d), DMA_LCM_TXAL = LOBYTE(d))
#define DMA_LCM_SetRxAddress(d)         (DMA_LCM_RXAH = HIBYTE(d), DMA_LCM_RXAL = LOBYTE(d))

/////////////////////////////////////////////////

#define DMAI2CTCFG_I2CTPTY_MSK          (BIT1 | BIT0)
#define DMAI2CRCFG_I2CRPTY_MSK          (BIT1 | BIT0)
#define DMA_I2C_SetTxBusPriority(n)     MODIFY_REG(DMA_I2CT_CFG,  DMAI2CTCFG_I2CTPTY_MSK, ((n) << 0))
#define DMA_I2C_SetRxBusPriority(n)     MODIFY_REG(DMA_I2CR_CFG,  DMAI2CRCFG_I2CRPTY_MSK, ((n) << 0))

#define DMAI2CTCR_ENI2CT_MSK            BIT7
#define DMAI2CRCR_ENI2CR_MSK            BIT7
#define DMA_I2C_EnableTx()              SET_REG_BIT(DMA_I2CT_CR, DMAI2CTCR_ENI2CT_MSK)
#define DMA_I2C_DisableTx()             CLR_REG_BIT(DMA_I2CT_CR, DMAI2CTCR_ENI2CT_MSK)
#define DMA_I2C_EnableRx()              SET_REG_BIT(DMA_I2CR_CR, DMAI2CRCR_ENI2CR_MSK)
#define DMA_I2C_DisableRx()             CLR_REG_BIT(DMA_I2CR_CR, DMAI2CRCR_ENI2CR_MSK)

#define DMAI2CTCR_TRIG_MSK              BIT6
#define DMAI2CRCR_TRIG_MSK              BIT6
#define DMA_I2C_TriggerTx()             SET_REG_BIT(DMA_I2CT_CR, DMAI2CTCR_TRIG_MSK)
#define DMA_I2C_TriggerRx()             SET_REG_BIT(DMA_I2CR_CR, DMAI2CRCR_TRIG_MSK)

#define DMAI2CRCR_CLRFIFO_MSK           BIT0
#define DMA_I2C_ClearFIFO()             SET_REG_BIT(DMA_I2CR_CR, DMAI2CRCR_CLRFIFO_MSK)

#define DMAI2CTSTA_TXOVW_MSK            BIT2
#define DMA_I2C_CheckOverWriteFlag()    READ_REG_BIT(DMA_I2CT_STA,  DMAI2CTSTA_TXOVW_MSK)
#define DMA_I2C_ClearOverWriteFlag()    CLR_REG_BIT(DMA_I2CT_STA,   DMAI2CTSTA_TXOVW_MSK)

#define DMAI2CRSTA_RXLOSS_MSK           BIT1
#define DMA_I2C_CheckRxLossFlag()       READ_REG_BIT(DMA_I2CR_STA,  DMAI2CRSTA_RXLOSS_MSK)
#define DMA_I2C_ClearRxLossFlag()       CLR_REG_BIT(DMA_I2CR_STA,   DMAI2CRSTA_RXLOSS_MSK)

#define DMA_I2C_SetTxAmount(d)          (DMA_I2CT_AMTH = HIBYTE(d), DMA_I2CT_AMT = LOBYTE(d))
#define DMA_I2C_SetRxAmount(d)          (DMA_I2CR_AMTH = HIBYTE(d), DMA_I2CR_AMT = LOBYTE(d))
#define DMA_I2C_ReadTxDone()            MAKEWORD(DMA_I2CT_DONE, DMA_I2CT_DONEH)
#define DMA_I2C_ReadRxDone()            MAKEWORD(DMA_I2CR_DONE, DMA_I2CR_DONEH)
#define DMA_I2C_SetTxAddress(d)         (DMA_I2CT_TXAH = HIBYTE(d), DMA_I2CT_TXAL = LOBYTE(d))
#define DMA_I2C_SetRxAddress(d)         (DMA_I2CR_RXAH = HIBYTE(d), DMA_I2CR_RXAL = LOBYTE(d))

#define DMAI2CCR_RDSEL_MSK              BIT7
#define DMA_I2C_ReadAmount()            CLR_REG_BIT(DMA_I2C_CR, DMAI2CCR_RDSEL_MSK)
#define DMA_I2C_ReadDone()              SET_REG_BIT(DMA_I2C_CR, DMAI2CCR_RDSEL_MSK)

#define DMAI2CCR_ACKERR_MSK             BIT2
#define DMA_I2C_CheckACK()              READ_REG_BIT(DMA_I2C_CR,  DMAI2CCR_ACKERR_MSK)

#define DMAI2CCR_ERRIE_MSK              BIT1
#define DMA_I2C_EnableACKErrorInt()     SET_REG_BIT(DMA_I2C_CR, DMAI2CCR_ERRIE_MSK)
#define DMA_I2C_DisableACKErrorInt()    CLR_REG_BIT(DMA_I2C_CR, DMAI2CCR_ERRIE_MSK)

#define DMAI2CCR_DMAEN_MSK              BIT0
#define DMA_I2C_EnableDMA()             SET_REG_BIT(DMA_I2C_CR, DMAI2CCR_DMAEN_MSK)
#define DMA_I2C_DisableDMA()            CLR_REG_BIT(DMA_I2C_CR, DMAI2CCR_DMAEN_MSK)

#define DMA_I2C_SetDMAAmount(d)         (DMA_I2C_ST2 = HIBYTE(d), DMA_I2C_ST1 = LOBYTE(d))
#define DMA_I2C_ReadDMAAmount()         MAKEWORD(DMA_I2C_ST1, DMA_I2C_ST2)
#define DMA_I2C_ReadDMADone()           MAKEWORD(DMA_I2C_ST1, DMA_I2C_ST2)


/////////////////////////////////////////////////

#define RSTCFG_P47RST_MSK               BIT4
#define RST_EnableResetPin()            SET_REG_BIT(RSTCFG, RSTCFG_P47RST_MSK)
#define RST_ResetPinAsGPIO()            CLR_REG_BIT(RSTCFG, RSTCFG_P47RST_MSK)

#define RSTCFG_ENLVR_MSK                BIT7
#define LVR_EnableLVR()                 SET_REG_BIT(RSTCFG, RSTCFG_ENLVR_MSK)
#define LVR_DisableLVR()                CLR_REG_BIT(RSTCFG, RSTCFG_ENLVR_MSK)

#define RSTCFG_LVDS_MSK                 (BIT1 | BIT0)
#define LVR_SetLVDS(n)                  MODIFY_REG(RSTCFG,  RSTCFG_LVDS_MSK, ((n) << 0))
#define LVR_SetLVDLevelV2p0()           LVR_SetLVDS(0)
#define LVR_SetLVDLevelV2p4()           LVR_SetLVDS(1)
#define LVR_SetLVDLevelV2p7()           LVR_SetLVDS(2)
#define LVR_SetLVDLevelV3p0()           LVR_SetLVDS(3)

/////////////////////////////////////////////////

#ifndef READ_LIN
#define READ_LIN(r)                     (LINAR = (r), READ_REG(LINDR))
#endif
#ifndef WRITE_LIN
#define WRITE_LIN(r, dat)               (LINAR = (r), WRITE_REG(LINDR, (dat)))
#endif
#ifndef MODIFY_LIN
#define MODIFY_LIN(r, clr, set)         (LINAR = (r), MODIFY_REG(LINDR, (clr), (set)))
#endif
#ifndef CLR_LIN_BIT
#define CLR_LIN_BIT(r, b)               (LINAR = (r), CLR_REG_BIT(LINDR, (b)))
#endif
#ifndef SET_LIN_BIT
#define SET_LIN_BIT(r, b)               (LINAR = (r), SET_REG_BIT(LINDR, (b)))
#endif
  

#define AUXR2_LINEN_MSK                 BIT0
#define LIN_Enable()                    SET_REG_BIT(AUXR2, AUXR2_LINEN_MSK)
#define LIN_Disable()                   CLR_REG_BIT(AUXR2, AUXR2_LINEN_MSK)

#define LINICR_LINIE_MSK                BIT1
#define LIN_EnableInt()                 SET_REG_BIT(LINICR, LINICR_LINIE_MSK)
#define LIN_DisableInt()                CLR_REG_BIT(LINICR, LINICR_LINIE_MSK)

#define LINICR_PLINL_MSK                BIT0
#define LINICR_PLINH_MSK                BIT3
#define LIN_SetIntPriority(n)           MODIFY_REG(LINICR, LINICR_PLINL_MSK, (((n) & 1) << 0)); \
                                        MODIFY_REG(LINICR, LINICR_PLINH_MSK, ((((n) >> 1) & 1) << 3))

#define LIN_ReadData()                  READ_LIN(LBUF)
#define LIN_WriteData(d)                WRITE_LIN(LBUF, (d))

#define LSEL_AINC_MSK                   BIT7
#define LIN_EnableAutoIncIndex()        SET_LIN_BIT(LSEL, LSEL_AINC_MSK)
#define LIN_DisableAutoIncIndex()       CLR_LIN_BIT(LSEL, LSEL_AINC_MSK)

#define LSEL_INDEX_MSK                  (BIT_LN)
#define LIN_SetDataIndex(i)             MODIFY_LIN(LSEL, LSEL_INDEX_MSK, ((i) << 0))

#define LID_ID_MSK                      (BIT5 | BIT4 | BIT_LN)
#define LIN_SetFrameID(n)               WRITE_LIN(LID, ((n) & LID_ID_MSK))
#define LIN_ReadFrameID()               (READ_LIN(LID) & LID_ID_MSK)

#define LER_OV_MSK                      BIT6
#define LER_SYN_MSK                     BIT5
#define LER_TOV_MSK                     BIT4
#define LER_CHK_MSK                     BIT3
#define LER_PER_MSK                     BIT2
#define LER_BIT_MSK                     BIT1
#define LER_FER_MSK                     BIT0
#define LIN_ReadAndClearError()         READ_LIN(LER)
#define LIN_CheckOVError(f)             READ_REG_BIT(f, LER_OV_MSK)
#define LIN_CheckSYNError(f)            READ_REG_BIT(f, LER_SYN_MSK)
#define LIN_CheckTOVError(f)            READ_REG_BIT(f, LER_TOV_MSK)
#define LIN_CheckCHKError(f)            READ_REG_BIT(f, LER_CHK_MSK)
#define LIN_CheckPERError(f)            READ_REG_BIT(f, LER_PER_MSK)
#define LIN_CheckBITError(f)            READ_REG_BIT(f, LER_BIT_MSK)
#define LIN_CheckFERError(f)            READ_REG_BIT(f, LER_FER_MSK)

#define LIE_ABORTE_MSK                  BIT3
#define LIE_ERRE_MSK                    BIT2
#define LIE_RDYE_MSK                    BIT1
#define LIE_LIDE_MSK                    BIT0
#define LIN_EnableAbortInt()            SET_LIN_BIT(LIE, LIE_ABORTE_MSK)
#define LIN_EnableErrorInt()            SET_LIN_BIT(LIE, LIE_ERRE_MSK)
#define LIN_EnableReadyInt()            SET_LIN_BIT(LIE, LIE_RDYE_MSK)
#define LIN_EnableHeaderInt()           SET_LIN_BIT(LIE, LIE_LIDE_MSK)
#define LIN_DisableAbortInt()           CLR_LIN_BIT(LIE, LIE_ABORTE_MSK)
#define LIN_DisableErrorInt()           CLR_LIN_BIT(LIE, LIE_ERRE_MSK)
#define LIN_DisableReadyInt()           CLR_LIN_BIT(LIE, LIE_RDYE_MSK)
#define LIN_DisableHeaderInt()          CLR_LIN_BIT(LIE, LIE_LIDE_MSK)

#define LSR_LOGSIZE_MSK                 (BIT_HN)
#define LSR_ABORT_MSK                   BIT3
#define LSR_ERR_MSK                     BIT2
#define LSR_RDY_MSK                     BIT1
#define LSR_LID_MSK                     BIT0
#define LIN_ReadAndClearStatus()        READ_LIN(LSR)
#define LIN_CheckAbort(f)               READ_REG_BIT(f, LSR_ABORT_MSK)
#define LIN_CheckError(f)               READ_REG_BIT(f, LSR_ERR_MSK)
#define LIN_CheckReady(f)               READ_REG_BIT(f, LSR_RDY_MSK)
#define LIN_CheckHeader(f)              READ_REG_BIT(f, LSR_LID_MSK)
#define LIN_GetLogSize(f)               (READ_REG_BIT(f, LSR_LOGSIZE_MSK) >> 4)

#define LCR_MODE_MSK                    BIT7
#define LIN_MASTER_MODE                 ((1 << 7) & LCR_MODE_MSK)
#define LIN_SLAVE_MODE                  ((0 << 7) & LCR_MODE_MSK)

#define LCR_LIN13_MSK                   BIT6
#define LIN_R1p3POTOCOL                 ((1 << 6) & LCR_LIN13_MSK)
#define LIN_R2p1POTOCOL                 ((0 << 6) & LCR_LIN13_MSK)

#define LCR_SIZE_MSK                    (BIT5 | BIT4 | BIT3 | BIT2)
#define LIN_FRAMESIZE(n)                (((n) << 2) & LCR_SIZE_MSK)

#define LCR_CMD_MSK                     (BIT1 | BIT0)
#define LIN_ABORTCMD                    (0 & LCR_CMD_MSK)
#define LIN_SENDHEADERCMD               (1 & LCR_CMD_MSK)
#define LIN_TXRESPONSECMD               (2 & LCR_CMD_MSK)
#define LIN_RXRESPONSECMD               (3 & LCR_CMD_MSK)

#define LIN_SendCommand(n)              WRITE_LIN(LCR, (n))

#define DLH_SYNC_MSK                    BIT7
#define LIN_EnableBaudRateSync()        SET_LIN_BIT(DLH, DLH_SYNC_MSK)
#define LIN_DisableBaudRateSync()       CLR_LIN_BIT(DLH, DLH_SYNC_MSK)

#define LIN_SetBaudRate(n)              WRITE_LIN(DLL, BYTE0(n)) ; \
                                        MODIFY_LIN(DLH, BYTE0(~DLH_SYNC_MSK), BYTE1(n))

#define LIN_SetHeaderDelay(n)           WRITE_LIN(HDRL, BYTE0(n)) ; \
                                        WRITE_LIN(HDRH, BYTE1(n))

#define HDP_PSCR_MSK                    (BIT5 | BIT4 | BIT_LN)
#define LIN_SetHeaderPrescale(n)        MODIFY_LIN(HDP, HDP_PSCR_MSK, ((n) << 0))

/////////////////////////////////////////////////

#ifndef READ_CAN
#define READ_CAN(r)                     (CANAR = (r), READ_REG(CANDR))
#endif
#ifndef WRITE_CAN
#define WRITE_CAN(r, dat)               (CANAR = (r), WRITE_REG(CANDR, (dat)))
#endif
#ifndef MODIFY_CAN
#define MODIFY_CAN(r, clr, set)         (CANAR = (r), MODIFY_REG(CANDR, (clr), (set)))
#endif
#ifndef CLR_CAN_BIT
#define CLR_CAN_BIT(r, b)               (CANAR = (r), CLR_REG_BIT(CANDR, (b)))
#endif
#ifndef SET_CAN_BIT
#define SET_CAN_BIT(r, b)               (CANAR = (r), SET_REG_BIT(CANDR, (b)))
#endif
#ifndef READ_CAN_BIT
#define READ_CAN_BIT(r, b)              (CANAR = (r), READ_REG_BIT(CANDR, (b)))
#endif

#define AUXR2_CAN1EN_MSK                BIT1
#define CAN1_Enable()                   SET_REG_BIT(AUXR2, AUXR2_CAN1EN_MSK)
#define CAN1_Disable()                  CLR_REG_BIT(AUXR2, AUXR2_CAN1EN_MSK)

#define AUXR2_CAN2EN_MSK                BIT2
#define CAN2_Enable()                   SET_REG_BIT(AUXR2, AUXR2_CAN2EN_MSK)
#define CAN2_Disable()                  CLR_REG_BIT(AUXR2, AUXR2_CAN2EN_MSK)

#define AUXR2_CANSEL_MSK                BIT3
#define CAN1_SEL()                      CLR_REG_BIT(AUXR2, AUXR2_CANSEL_MSK)
#define CAN2_SEL()                      SET_REG_BIT(AUXR2, AUXR2_CANSEL_MSK)

#define CANICR_CAN1IE_MSK               BIT1
#define CAN1_EnableInt()                SET_REG_BIT(CANICR, CANICR_CAN1IE_MSK)
#define CAN1_DisableInt()               CLR_REG_BIT(CANICR, CANICR_CAN1IE_MSK)

#define CANICR_PCAN1L_MSK               BIT0
#define CANICR_PCAN1H_MSK               BIT3
#define CAN1_SetIntPriority(n)          MODIFY_REG(CANICR, CANICR_PCAN1L_MSK, (((n) & 1) << 0)); \
                                        MODIFY_REG(CANICR, CANICR_PCAN1H_MSK, ((((n) >> 1) & 1) << 3))

#define CANICR_CAN2IE_MSK               BIT5
#define CAN2_EnableInt()                SET_REG_BIT(CANICR, CANICR_CAN2IE_MSK)
#define CAN2_DisableInt()               CLR_REG_BIT(CANICR, CANICR_CAN2IE_MSK)

#define CANICR_PCAN2L_MSK               BIT4
#define CANICR_PCAN2H_MSK               BIT7
#define CAN2_SetIntPriority(n)          MODIFY_REG(CANICR, CANICR_PCAN2L_MSK, (((n) & 1) << 0)); \
                                        MODIFY_REG(CANICR, CANICR_PCAN2H_MSK, ((((n) >> 1) & 1) << 3))

#define MR_RM_MSK                       BIT2
#define CAN_EnterResetMode()            SET_CAN_BIT(MR, MR_RM_MSK)
#define CAN_ExitResetMode()             CLR_CAN_BIT(MR, MR_RM_MSK)

#define MR_LOM_MSK                      BIT1
#define CAN_ListenOnlyMode()			SET_CAN_BIT(MR, MR_LOM_MSK)
#define CAN_NormalMode()				CLR_CAN_BIT(MR, MR_LOM_MSK)

#define MR_AFM_MSK                      BIT0
#define CAN_SingleFilter()              SET_CAN_BIT(MR, MR_AFM_MSK)
#define CAN_DoubleFilter()              CLR_CAN_BIT(MR, MR_AFM_MSK)

#define CMR_TR_MSK                      BIT2
#define CMR_AT_MSK                      BIT1
#define CAN_TriggerTransmit()           WRITE_CAN(CMR, CMR_TR_MSK)
#define CAN_AbortTransmit()             WRITE_CAN(CMR, CMR_AT_MSK)

#define SR_RBS_MSK                      BIT7
#define SR_DSO_MSK                      BIT6
#define SR_TBS_MSK                      BIT5
#define SR_RS_MSK                       BIT3
#define SR_TS_MSK                       BIT2
#define SR_ES_MSK                       BIT1
#define SR_BS_MSK                       BIT0
#define CAN_CheckRBufferStatus()        READ_CAN_BIT(SR, SR_RBS_MSK)
#define CAN_CheckOverrunStatus()        READ_CAN_BIT(SR, SR_DSO_MSK)
#define CAN_CheckTBufferStatus()        READ_CAN_BIT(SR, SR_TBS_MSK)
#define CAN_CheckReceiveStatus()        READ_CAN_BIT(SR, SR_RS_MSK)
#define CAN_CheckTransmitStatus()       READ_CAN_BIT(SR, SR_TS_MSK)
#define CAN_CheckErrorStatus()          READ_CAN_BIT(SR, SR_ES_MSK)
#define CAN_CheckBusOffStatus()         READ_CAN_BIT(SR, SR_BS_MSK)

#define ISR_ALI_MSK                     BIT6
#define ISR_EWI_MSK                     BIT5
#define ISR_EPI_MSK                     BIT4
#define ISR_RI_MSK                      BIT3
#define ISR_TI_MSK                      BIT2
#define ISR_EBI_MSK                     BIT1
#define ISR_DOI_MSK                     BIT0
#define CAN_CheckArbitrateLost(f)       READ_CAN_BIT((f), ISR_ALI_MSK)
#define CAN_CheckErrorWarning(f)        READ_CAN_BIT((f), ISR_EWI_MSK)
#define CAN_CheckErrorPassive(f)        READ_CAN_BIT((f), ISR_EPI_MSK)
#define CAN_CheckReceive(f)             READ_CAN_BIT((f), ISR_RI_MSK)
#define CAN_CheckTransmit(f)            READ_CAN_BIT((f), ISR_TI_MSK)
#define CAN_CheckBusError(f)            READ_CAN_BIT((f), ISR_EBI_MSK)
#define CAN_CheckDataOverrun(f)         READ_CAN_BIT((f), ISR_DOI_MSK)

#define CAN_ReadIntStatus()             READ_CAN(ISR)
#define CAN_ClearFlags(f)               WRITE_CAN(ISR, (f))

#define IMR_ALIM_MSK                    BIT6
#define IMR_EWIM_MSK                    BIT5
#define IMR_EPIM_MSK                    BIT4
#define IMR_RIM_MSK                     BIT3
#define IMR_TIM_MSK                     BIT2
#define IMR_EBIM_MSK                    BIT1
#define IMR_DOIM_MSK                    BIT0
#define CAN_EnableArbitrateLostInt()    SET_CAN_BIT(IMR, IMR_ALIM_MSK)
#define CAN_EnableErrorWarningInt()     SET_CAN_BIT(IMR, IMR_EWIM_MSK)
#define CAN_EnableErrorPassiveInt()     SET_CAN_BIT(IMR, IMR_EPIM_MSK)
#define CAN_EnableReceiveInt()          SET_CAN_BIT(IMR, IMR_RIM_MSK)
#define CAN_EnableTransmitInt()         SET_CAN_BIT(IMR, IMR_TIM_MSK)
#define CAN_EnableBusErrorInt()         SET_CAN_BIT(IMR, IMR_EBIM_MSK)
#define CAN_EnableDataOverrunInt()      SET_CAN_BIT(IMR, IMR_DOIM_MSK)
#define CAN_DisableArbitrateLostInt()   CLR_CAN_BIT(IMR, IMR_ALIM_MSK)
#define CAN_DisableErrorWarningInt()    CLR_CAN_BIT(IMR, IMR_EWIM_MSK)
#define CAN_DisableErrorPassiveInt()    CLR_CAN_BIT(IMR, IMR_EPIM_MSK)
#define CAN_DisableReceiveInt()         CLR_CAN_BIT(IMR, IMR_RIM_MSK)
#define CAN_DisableTransmitInt()        CLR_CAN_BIT(IMR, IMR_TIM_MSK)
#define CAN_DisableBusErrorInt()        CLR_CAN_BIT(IMR, IMR_EBIM_MSK)
#define CAN_DisableDataOverrunInt()     CLR_CAN_BIT(IMR, IMR_DOIM_MSK)

#define BTR0_SJW_MSK                    (BIT7 | BIT6)
#define CAN_SetSJW(n)                   MODIFY_CAN(BTR0, BTR0_SJW_MSK, ((n) << 6))

#define BTR0_BRP_MSK                    (BIT5 | BIT4 | BIT_LN)
#define CAN_SetBRP(n)                   MODIFY_CAN(BTR0, BTR0_BRP_MSK, ((n) << 0))

#define BTR1_SAM_MSK                    BIT7
#define CAN_SampleOnce()                CLR_CAN_BIT(BTR1, BTR1_SAM_MSK)
#define CAN_Sample3Times()              SET_CAN_BIT(BTR1, BTR1_SAM_MSK)

#define BTR1_TSG2_MSK                   (BIT6 | BIT5 | BIT4)
#define CAN_SetTSG2(n)                  MODIFY_CAN(BTR1, BTR1_TSG2_MSK, ((n) << 4))

#define BTR1_TSG1_MSK                   (BIT_LN)
#define CAN_SetTSG1(n)                  MODIFY_CAN(BTR1, BTR1_TSG1_MSK, ((n) << 0))

#define CAN_WriteBUF0(d)                WRITE_CAN(TX_BUF0, (d))
#define CAN_WriteBUF1(d)                WRITE_CAN(TX_BUF1, (d))
#define CAN_WriteBUF2(d)                WRITE_CAN(TX_BUF2, (d))
#define CAN_WriteBUF3(d)                WRITE_CAN(TX_BUF3, (d))

#define CAN_WriteBUF(n, d)              WRITE_CAN(TX_BUF0 + ((n) & 0x03), (d))

#define CAN_ReadBUF0()                  READ_CAN(RX_BUF0)
#define CAN_ReadBUF1()                  READ_CAN(RX_BUF1)
#define CAN_ReadBUF2()                  READ_CAN(RX_BUF2)
#define CAN_ReadBUF3()                  READ_CAN(RX_BUF3)

#define CAN_ReadBUF(n)                  READ_CAN(RX_BUF0 + ((n) & 0x03))

#define CAN_SetACR0(d)                  WRITE_CAN(ACR0, (d))
#define CAN_SetACR1(d)                  WRITE_CAN(ACR1, (d))
#define CAN_SetACR2(d)                  WRITE_CAN(ACR2, (d))
#define CAN_SetACR3(d)                  WRITE_CAN(ACR3, (d))

#define CAN_SetAMR0(d)                  WRITE_CAN(AMR0, (d))
#define CAN_SetAMR1(d)                  WRITE_CAN(AMR1, (d))
#define CAN_SetAMR2(d)                  WRITE_CAN(AMR2, (d))
#define CAN_SetAMR3(d)                  WRITE_CAN(AMR3, (d))

#define ECC_RXWRN_MSK                   BIT7
#define ECC_TXWRN_MSK                   BIT6
#define ECC_EDIR_MSK                    BIT5
#define ECC_ACKER_MSK                   BIT4
#define ECC_FRMER_MSK                   BIT3
#define ECC_CRCER_MSK                   BIT2
#define ECC_STFER_MSK                   BIT1
#define ECC_BER_MSK                     BIT0
#define CAN_CheckRxWarning()            READ_CAN_BIT(ECC, ECC_RXWRN_MSK)
#define CAN_CheckTxWarning()            READ_CAN_BIT(ECC, ECC_TXWRN_MSK)
#define CAN_CheckDirError()             READ_CAN_BIT(ECC, ECC_EDIR_MSK)
#define CAN_CheckACKError()             READ_CAN_BIT(ECC, ECC_ACKER_MSK)
#define CAN_CheckFrameError()           READ_CAN_BIT(ECC, ECC_FRMER_MSK)
#define CAN_CheckCRCError()             READ_CAN_BIT(ECC, ECC_CRCER_MSK)
#define CAN_CheckStuffError()           READ_CAN_BIT(ECC, ECC_STFER_MSK)
#define CAN_CheckBitError()             READ_CAN_BIT(ECC, ECC_BER_MSK)

#define CAN_GetRecvMsgCount()           READ_CAN(RMC)
#define CAN_GetRxErrCount()             READ_CAN(RXERR)
#define CAN_GetTxErrCount()             READ_CAN(TXERR)
#define CAN_GetArbitrateLostCode()      READ_CAN(ALC)

#define CAN_EXTENDED_MSK                BIT7
#define CAN_REMOTE_MSK                  BIT6
#define CANFMT_STDDAT                   (0)
#define CANFMT_STDRMT                   (CAN_REMOTE_MSK)
#define CANFMT_EXTDAT                   (CAN_EXTENDED_MSK)
#define CANFMT_EXTRMT                   (CAN_EXTENDED_MSK | CAN_REMOTE_MSK)

#define CAN_DLC_MSK                     (BIT_LN)
#define CAN_DATALEN(n)                  (((n) << 0) & CAN_DLC_MSK)

#define CANID_STD(n)                    ((n) << 5)
#define CANID_EXT(n)                    ((n) << 3)

/////////////////////////////////////////////////

#endif

